unit ObjectInspec;

interface

{$Include handel.inc}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Grids, ExtCtrls,TypInfo,DsgnIntf, Buttons, Menus,
  DBTables, ImgList;

type
  TObjectInspector = class(TForm)
    PageControl1: TPageControl;
    TabProperty: TTabSheet;
    TabEvent: TTabSheet;
    Panel1: TPanel;
    ComponentList: TComboBox;
    FontDialog1: TFontDialog;
    PropertyBox: TListBox;
    EventBox: TListBox;
    cbValue: TComboBox;
    edProperty: TEdit;
    Browse: TPanel;
    InspectorMenu: TPopupMenu;
    StayOnTopItem: TMenuItem;
    HideItem: TMenuItem;
    HelpItem: TMenuItem;
    N9: TMenuItem;
    InformationItem: TMenuItem;
    StatusBar1: TStatusBar;
    cbEvent: TComboBox;
    TabCodeExplorer: TTabSheet;
    TreeView: TTreeView;
    TreeImages: TImageList;
    ExplorerMenu: TPopupMenu;
    AlphaSort1: TMenuItem;
    LineSort1: TMenuItem;
    N1: TMenuItem;
    ReFresh1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure ComboValueChange(Sender: TObject);
    procedure StringGrid2DblClick(Sender: TObject);
    procedure PropertyBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure PropertyBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PropertyBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PropertyBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure EventBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure EventBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure EventBoxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure EventBoxMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PropertyBoxClick(Sender: TObject);
    procedure PropertyBoxKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure EventBoxClick(Sender: TObject);
    procedure cbValueDblClick(Sender: TObject);
    procedure BrowseClick(Sender: TObject);
    procedure edPropertyKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure edPropertyKeyPress(Sender: TObject; var Key: Char);
    procedure cbValueChange(Sender: TObject);
    procedure cbValueKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cbValueDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure FormActivate(Sender: TObject);
    procedure ComponentListClick(Sender: TObject);
   // procedure edEventDblClick(Sender: TObject);
    procedure PropertyBoxDblClick(Sender: TObject);
    procedure HideItemClick(Sender: TObject);
    procedure StayOnTopItemClick(Sender: TObject);
    procedure InformationItemClick(Sender: TObject);
    procedure cbEventDblClick(Sender: TObject);
    procedure cbEventKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure TreeViewDblClick(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure AlphaSort1Click(Sender: TObject);
    procedure LineSort1Click(Sender: TObject);
    procedure ReFresh1Click(Sender: TObject);
    procedure TreeViewChange(Sender: TObject; Node: TTreeNode);
    procedure cbEventClick(Sender: TObject);
  private
    { Private declarations }
    EventCount:integer;
    fComponent: TComponent;
    fPropertyName : string;
    fPropertyAttr: TPropertyAttributes;
    PropertyList: TStringList;
    EventList: TStringList;
    SubPos:Integer;
    HalfWay: Integer;
    EditRect: TRect;
    SplitDrag: Boolean;
    fPropertyEditor: TPropertyEditor;
    function  ExtractComponentName(const S:string):string;
    procedure ClearProperties;
    procedure GetProperties(Component: TComponent);
    procedure GetPropEditor(Editor: TPropertyEditor);
    procedure GetEventEditor(Editor: TPropertyEditor);
    procedure SetEditor(Editor: TPropertyEditor);
    function  GetComponentName: string;
    function  GetComponent(var Wrapper:TComponent): TComponent;
    procedure EditorProperty;
    procedure PropSetValue(const Value: string);
    procedure UpdateValue;
    function  GetPropValue(Info:PPropInfo):TStringList;
    procedure InsertPropInfo(Info:PPropInfo;Sender:TObject);
    procedure DeletePropInfo(Info:PPropInfo;Sender:TObject);
    procedure SetEditBounds(AControl : TWinControl);
    procedure GetValueProc(const Value: string);
    procedure GetSubPropEditor(Editor: TPropertyEditor);
    function  GetPropertyName: string;
    function  GetEventName: string;
    function  GetPropertyValueName: string;
    function  GetPropertyBoxValue(DBName:string): string ;
    function  GetEventValueName: string;
    procedure SetPropertyValueName(Value:string) ;
    procedure SetcbValueIndex(Text:string);
    procedure ShowHelp;
    procedure GetPrpoertyItemList(ClassName:string;CanParent:Boolean);
    function  GetClassList(ClassName:string;CanParent:Boolean):string;
    function  ExtractComponentType(const S:string):string;
    procedure GetDatabaseNameList;
    procedure GetTableNameList;
    procedure GetEventValueProc(const Value: string);
    function  GetItemIndex(Component: TComponent): Integer;
  protected
    procedure Initialize(Component: TComponent);
  public
    { Public declarations }
     constructor CreateMain(Owner: TComponent; Component: TComponent);
     function  WritePropInfo(Info:PPropInfo;I:integer;Sender:TObject):string;
     procedure WritePropertyInfo(Info:PTypeInfo;Data:PTypeData;Sender:TObject);
     procedure GetPropertyInfo(Sender: TObject);
     procedure DisplayProperty(Wrapper,Component:TComponent);
     procedure InitializeInspector;
     procedure EditEventHandler(Index: Integer);
     procedure InsertIntoList(Item: string; LineNumber: Integer; Child: Boolean);
     property  PropertyEditor: TPropertyEditor read fPropertyEditor;
     property  PropertyName: string read GetPropertyName write fPropertyName;
     property  SelectComponent: TComponent read fComponent write fComponent;
     property  PropAttrs: TPropertyAttributes read fPropertyAttr;
 end;

var
  ObjectInspector: TObjectInspector;

implementation

uses Proxy, MainForm, utype, Editor,propedit,uconst, rttiinfo;

type
   TIntegerSet=set of 0..Sizeof(Integer)*8-1;

{$R *.DFM}

  TParamFlag = (pfVar, pfConst, pfArray);
  TParamFlags = set of TParamFlag;
  PParamString = PShortString;
  TParamInfo = record
    Flags: TParamFlags;
    ParamName: PParamString;
    ParamType: PParamString;
  end;
  TParamList = array[0..255] of TParamInfo;
  PParamList = ^TParamList;


{ Like 'is,' but works with a string. }
function IsA(PI : PTypeInfo; S : String) : Boolean;
var
   PTD : PTypeData;
   PTI : PTypeInfo;
   Found : Boolean;
Begin
  Found := False;
  S := UpperCase(S);
  PTI := PI;
  while (not Found) and (UpperCase(PTI^.Name) <> 'TOBJECT') do
  begin
    Found := UpperCase(PTI^.Name) = S;
    PTD := GetTypeData(PTI);
    PTI := PTD^.ParentInfo^;
  end;
  IsA := Found;
End;

{ Get the infromation for a parameter list, and store
  it in the ParamList argument. }
procedure GetParamInfo(Data: PTypeData; var Params: TParamList;
                       var ReturnType: PParamString);
var
  I: Integer;
  Ptr: PByte;
begin
  with Data^ do
  begin
    Ptr := PByte(@ParamList);
    for I := 0 to ParamCount-1 do
      with Params[I] do
      begin
        Flags := TParamFlags(Ptr^);
        Inc(Ptr);
        ParamName := PParamString(Ptr);
        Inc(Ptr, Length(ParamName^) + 1);
        ParamType := PParamString(Ptr);
        Inc(Ptr, Length(ParamType^) + 1);
      end;
    if MethodKind = mkFunction then
      ReturnType := PParamString(Ptr);
  end;
end;

{ Write the information for a method, including all the parameters.
  If the method is a function, then show the return type, too. }

function WriteMethodData(Data: PTypeData):string;
var
  I: Integer;
  Params: PParamList;
  Return: PParamString;
  MethodPara:string;
begin
  with Data^ do
  begin
    { Allocate memory to hold all the parameter information }
    GetMem(Params, ParamCount * SizeOf(TParamInfo));
    try
      GetParamInfo(Data, Params^, Return);
      { Write each parameter: }
      for I := 0 to ParamCount-1 do
        with Params^[I] do
        begin
          if pfVar in Flags then
            MethodPara:=MethodPara+'var ';
          if pfConst in Flags then
            MethodPara:=MethodPara+'const ';
          MethodPara:=MethodPara+ParamName^+ ': ';
          if pfArray in Flags then
            MethodPara:=MethodPara+'array of ';
          MethodPara:=MethodPara+ParamType^+';';
        end;
    finally
      FreeMem(Params, ParamCount * SizeOf(TParamInfo));
    end;
  end;
  if MethodPara[Length(MethodPara)]=';' then
     MethodPara:=Copy(MethodPara,1,Length(MethodPara)-1);
  Result:=MethodPara;
end;

// Custom Sort Procedure for treeview
function CustomSortProc(node1, node2: TTreenode; Data: Integer): Integer; stdcall;
begin
 Result := 0;
 // else sort on linenumbers
  if Integer(node1.Data) > Integer(node2.Data) then Result := 1;
  if Integer(node1.Data) < Integer(node2.Data) then Result := -1;
end;

constructor TObjectInspector.CreateMain(Owner: TComponent; Component: TComponent);
begin
  inherited Create(Owner);
  Initialize(Component);
  GetProperties(Component);
end;

function TObjectInspector.WritePropInfo(Info:PPropInfo;I:integer;Sender:TObject):string;
// Ư Ӽ Ǵ ̺Ʈ   ش.
var
   PropValue, Temp:string;
   OrdValue,MinVal,MaxVal:integer;
   Data:PTypeData;
   S:TIntegerSet;
   J:Integer;
   TypeInfo1:PTypeInfo;
   MethodValue: TMethod;
begin
    Result:= '';
    PropValue:= '';
    if Sender = nil then Exit;
    if Info^.PropType^.Kind = tkMethod then
    begin
       MethodValue:= GetMethodProp(Sender,Info);
       if (MethodValue.Code <> nil) then
          PropValue:= ProxyDesigner.GetMethodName(MethodValue)
       else
       begin
          Temp:= TControl(Sender).Name + Copy(Info^.Name, 3, Length(Info^.Name));
          J:= ProxyDesigner.Methods.IndexOf(Temp);
          if J <> -1 then PropValue:= ProxyDesigner.Methods[J];
       end;
       Inc(EventCount,1);
    end
    else
    begin
      case Info^.PropType^.Kind of
          tkString,tkLString:
             PropValue:= GetStrProp(Sender,Info);
          tkEnumeration:
          begin
              OrdValue:= GetOrdProp(Sender,Info);
              if Info.Name = 'BOOLEAN' then
              begin
                  if OrdValue = 0 then PropValue:= 'False'
                  else PropValue:= 'True'
              end
              else
              begin
                  PropValue:= GetEnumName(Info.PropType^,OrdValue);
              end;
          end;
          tkClass:
          begin
              Data:= GetTypeData(Info^.PropType^);
              if Data^.PropCount>0 then
                 PropValue:= '('+Data^.ClassType.ClassName+')';
          end;
          tkInteger:
          begin
              OrdValue := GetOrdProp(Sender,Info);
              PropValue:= UpperCase(Info.Name);
              if Pos('COLOR',PropValue)>0 then // Ӽ Color 
                 PropValue:= ColorToString(TColor(OrdValue))
              else if Pos('CURSOR',PropValue)>0 then // Ӽ cursor 
                 PropValue:= CursorToString(TCursor(OrdValue))
              else PropValue:= IntToStr(OrdValue);
          end;
          tkSet:
          begin
              Data:= GetTypeData(Info^.PropType^);
              TypeInfo1:= Data^.CompType^;
              Data  := GetTypeData(TypeInfo1);
              MinVal:= Data^.MinValue;
              MaxVal:= Data^.MaxValue;
              Integer(S):= GetOrdProp(Sender,Info);
              PropValue:='[';
              for J:=MinVal to MaxVal do
                if I in S then
                begin
                    if Length(PropValue)<>1 then PropValue:= PropValue+',';
                    PropValue:= PropValue + GetEnumName(TypeInfo1,J);
                 end;
              PropValue:= PropValue+']';
          end;
       end;
    end;
    Result:= PropValue;
end;

procedure TObjectInspector.InsertPropInfo(Info:PPropInfo;Sender:TObject);
//  Ӽ  Ӽ  Ӽ ش.
var
   PropName, PropValue, Prop:string;
   Data:PTypeData;
   I, Count:Integer;
   TypeInfo:PTypeInfo;
   PropList:PPropList;
begin
   if Info = nil then Exit;
   if Sender<>nil then
   begin
      TypeInfo:= Info^.PropType^;
      Count:= GetPropList(TypeInfo,tkProperties,nil);
      GetMem(PropList, Count*SizeOf(PPropInfo));
      GetPropInfos(TypeInfo, PropList);
      case Info^.PropType^.Kind of
          tkClass:
          begin
              Data:= GetTypeData(Info^.PropType^);
              for I:=0 to Data^.PropCount - 1 do
              begin
                 PropName:= '  ' + PropList^[I].Name;
                 Prop:= Format('%-20s%-20s',[PropName, PropValue]);
                 PropertyBox.Items.Insert(PropertyBox.ItemIndex + 1, Prop);
              end;
          end;
      end;
      FreeMem(PropList, Count*SizeOf(PPropInfo));
   end;
end;

procedure TObjectInspector.DeletePropInfo(Info:PPropInfo;Sender:TObject);
//  Ӽ  Ӽ  Ӽ .
var
   Data:PTypeData;
   I,MinVal,MaxVal:Integer;
   TypeInfo:PTypeInfo;
begin
   if Info = nil then Exit;
   if Sender <> nil then
   begin
      case Info^.PropType^.Kind of
          tkClass:
          begin
              Data:= GetTypeData(Info^.PropType^);
              for I:= Data^.PropCount - 1 downto 0 do
              begin
                 PropertyList.Delete(PropertyBox.ItemIndex + I + 1);
                 PropertyBox.Items.Delete(PropertyBox.ItemIndex + I + 1);
              end;
          end;
          tkSet:
          begin
              Data    := GetTypeData(Info^.PropType^);
              TypeInfo:= Data^.CompType^;
              Data    := GetTypeData(TypeInfo);
              MinVal  := Data^.MinValue;
              MaxVal  := Data^.MaxValue;
              for I:= MaxVal-MinVal  downto 0 do
              begin
                 PropertyList.Delete(PropertyBox.ItemIndex + I + 1);
                 PropertyBox.Items.Delete(PropertyBox.ItemIndex + I + 1);
              end;
          end;
      end;
   end;
end;

procedure TObjectInspector.WritePropertyInfo(Info:PTypeInfo;Data:PTypeData;Sender:TObject);
// Ư Ŭ  Ӽ ̺Ʈ  Ѵ.
var
   I,Count,Count1:integer;
   PropList,PropList1:PPropList;
   Prop:string;

procedure AddPropItem(ListBox:TListBox;Info:PPropInfo);
var
  Editor: TPropertyEditor;
begin
  {  Editor:= TPropertyEditor(PropertyList.Objects[I]);
    if Editor <> nil then
    begin
       fPropertyAttr:= Editor.GetAttributes;
       if (paSubProperties in PropAttrs) then
       begin
         ListBox.Items.Add(Format('+%-20s',[Info^.Name])+ Prop);
       end
       else
          ListBox.Items.Add(Format('%-20s',[Info^.Name])+ Prop);
    end;}

    if Info^.PropType^.Kind in [tkClass] then
    begin
       if IsA(Info^.PropType^, 'TCOMPONENT') then
          ListBox.Items.Add(Format('%-20s',[Info^.Name])+ Prop)
       else ListBox.Items.Add(Format('+%-20s',[Info^.Name])+ Prop);
    end
    else if Info^.PropType^.Kind in [tkSet] then
       ListBox.Items.Add(Format('+%-20s',[Info^.Name])+ Prop)
    else if Info^.PropType^.Kind in [tkMethod] then
       ListBox.Items.Add(Format('%-20s',[Info^.Name])+ Prop)
    else ListBox.Items.Add(Format('%-20s',[Info^.Name])+ Prop);

end;
begin
    EventCount:=0;
    Count := GetPropList(Info,tkProperties,nil);   // get property count
    Count1:= GetPropList(Info,tkMethods,nil);      // get event count
    GetMem(PropList,Count*SizeOf(PPropInfo));
    GetMem(PropList1,Count1*SizeOf(PPropInfo));
    try
       GetPropList(Info,tkProperties,PropList);
       for I:=0 to Count-1 do
       begin
          Prop:= WritePropInfo(PropList^[I],I,Sender);
          AddPropItem(PropertyBox, PropList^[I]);
       end;
       GetPropList(Info,tkMethods,PropList1);
       for I:=0 to Count1-1 do
       begin
          Prop:= WritePropInfo(PropList1^[I],I,Sender);
          AddPropItem(EventBox, PropList1^[I]);
       end;
    finally
       FreeMem(PropList,Count*SizeOf(PPropInfo));
       FreeMem(PropList1,Count1*SizeOf(PPropInfo));
    end;
end;

procedure TObjectInspector.ClearProperties;
begin
   PropertyBox.Clear;
   EventBox.Clear;
   PropertyList.Clear;
end;

procedure TObjectInspector.GetPropertyInfo(Sender: TObject);
// Get property, event list and value for selected component
var
  Info:PTypeInfo;
  Data:PTypeData;
begin
   Info:= Sender.ClassInfo;
   if Info = nil then Exit;
   Data:= GetTypeData(Info);
   GetProperties(Sender as TComponent);
   WritePropertyInfo(Info,Data,Sender);
end;

{ The user has chosen a property, so get the editor,
  and initialize the property editor fields. }
procedure TObjectInspector.SetEditor(Editor: TPropertyEditor);
var
   PTypeName, ClassName:string;
begin
   fPropertyEditor:= Editor;
   if Editor= nil then  Exit;
   Editor.Activate;
   fPropertyAttr:= Editor.GetAttributes;
   if (paDialog in PropAttrs) then SetEditBounds(Browse)
   else SetEditBounds(nil);
   cbValue.Clear;
   PTypeName:= Editor.GetPropType.Name;
   ClassName:= Editor.ClassName;
   //Ӽ ̺Ʈ ƴϰ    Ӽ  ش.
   if ((paValueList in PropAttrs) and (ClassName<>'TMethodProperty')) then
   begin
      Editor.GetValues(GetValueProc);
      SetEditBounds(cbValue);
   end
   else if (ClassName ='TMethodProperty') then
   begin
    // Editor.GetValues(GetEventValueProc);
     cbEvent.Items.Assign(ProxyDesigner.Methods);
     SetEditBounds(cbEvent);
   end
   else if ClassName='TFontProperty'     then SetEditBounds(Browse)
   else if (PTypeName = 'TBitmap')       then SetEditBounds(Browse)
   else if (PTypeName = 'TIcon')         then SetEditBounds(Browse)
   else if (PTypeName = 'TTabSheet')     then GetPrpoertyItemList('TTabSheet', False)
   else if (PTypeName = 'TWinControl')   then GetPrpoertyItemList('TWinControl', True)
   else if (GetPropertyName = 'DatabaseName') then GetDatabaseNameList
   else if (GetPropertyName = 'TableName')    then GetTableNameList
   else SetEditBounds(edProperty);
   StatusBar1.SimpleText:= Editor.GetPropType.Name+' : '+ClassName;
   // Ӽ ̺Ʈ ƴϸ Ӽ Ѵ.
   if (ClassName<>'TMethodProperty') then  UpdateValue;
   if edProperty.Visible then  edProperty.Text:= Editor.GetValue
   else if cbValue.Visible then  SetcbValueIndex(Editor.GetValue)
  // else if cbEvent.Visible then  cbEvent.Text:= Editor.GetValue;
end;

{ Callback for getting a subproperty editor. }
procedure TObjectInspector.GetPropEditor(Editor: TPropertyEditor);
begin
   Editor.Initialize;
   PropertyList.AddObject(Editor.GetName, Editor);
end;

// Font  SubProperties  Ӽ  Ӽ
// ִ Callback ν
procedure TObjectInspector.GetSubPropEditor(Editor: TPropertyEditor);
var
  Prop:string;
begin
   Editor.Initialize;
   Prop:= Format('  %-18s%-s',[Editor.GetName, Editor.GetValue]);
   PropertyList.InsertObject(PropertyBox.ItemIndex + 1, Editor.GetName, Editor);
   PropertyBox.Items.Insert(PropertyBox.ItemIndex + 1, Prop);
end;

procedure TObjectInspector.GetEventEditor(Editor: TPropertyEditor);
begin
   EventList.AddObject(Editor.GetName, Editor);
end;

procedure TObjectInspector.GetProperties(Component: TComponent);
// ۳Ʈ  ִ Ӽ   ش.
var
  CompList: TComponentList;
  Comp1List: TComponentList;
begin
  PropertyList.BeginUpdate;
  EventList.BeginUpdate;
  ClearProperties;
  CompList := TComponentList.Create;
  Comp1List:= TComponentList.Create;
  try
    CompList.Add(Component);
    Comp1List.Add(Component);
    // ۳ƮComponent  Ӽ ⸦ Ѵ.(Ӽ  )
    GetComponentProperties(CompList, tkProperties,ProxyDesigner , GetPropEditor);
    // ۳Ʈ  Ӽ(̺Ʈ)  Ӽ ⸦ Ѵ.( ̺Ʈ)
    GetComponentProperties(Comp1List, tkMethods, ProxyDesigner, GetEventEditor);
  finally
    CompList.Free;
    Comp1List.Free;
  end;
  PropertyList.EndUpdate;
  EventList.EndUpdate;
end;

{ Initialize the property editor form. }
procedure TObjectInspector.Initialize(Component: TComponent);
begin
  {$IFDEF DELPHI3}
  Designer := ProxyDesigner;
  {$ENDIF}
  fComponent := Component;
end;

procedure TObjectInspector.FormCreate(Sender: TObject);
begin
   propedit.Register;   //  Ӽ ⸦ Ѵ.
   PropertyList:= TStringList.Create;
   EventList   := TStringList.Create;
   Left:=0;
   PageControl1.ActivePage:=TabProperty;
   ComponentList.Items.Add('Form1:TForm1');
end;

procedure TObjectInspector.FormResize(Sender: TObject);
//  ũⰡ ٲ   Ʈ ̸ Ѵ.
begin
   ComponentList.Width:=Width-10;
   EditRect.Right := PropertyBox.ItemRect(PropertyBox.ItemIndex).Right;
   if Browse.Visible then SetEditBounds(Browse)
   else if edProperty.Visible then SetEditBounds(edProperty)
   else if cbEvent.Visible then SetEditBounds(cbEvent)
   else if cbValue.Visible then SetEditBounds(cbValue);
end;

function TObjectInspector.ExtractComponentName(const S:string):string;
// Ʈ νƮ ۳Ʈ Ͽ ۳Ʈ ̸ Ѵ.
var
  SepaPos:integer;
begin
   Result:='';
   SepaPos:=Pos(':',S);
   if SepaPos>1 then Result:= Copy(S,1,SepaPos-1);
end;

function TObjectInspector.ExtractComponentType(const S:string):string;
// Ʈ νƮ ۳Ʈ Ͽ ۳Ʈ type Ѵ.
var
  SepaPos:integer;
begin
   Result:='';
   if S = '' then Exit;
   SepaPos:=Pos(':',S);
   if SepaPos > 1 then Result:= Copy(S,SepaPos + 1, Length(S));
end;

function TObjectInspector.GetComponentName: string;
//   ۳Ʈ ̸ ش.
begin
  with ComponentList do
    if ItemIndex<0 then Result := ''
    else  Result := ExtractComponentName(Items[ItemIndex]);
end;

// Object Inspector  ۳Ʈ ش.
// ð ۳Ʈ  쿡 Wrapper WrapperControl ҴѴ.
function TObjectInspector.GetComponent(var Wrapper:TComponent): TComponent;
var
  WrapperName,ComponentName:string;
  Component:TComponent;
begin
  Result:= nil;
  if ProxyDesigner = nil then Exit;
  Wrapper:= nil;
  ComponentName:= GetComponentName;
  WrapperName:= 'Wrapper'+ComponentName;
  if ComponentName = ProxyDesigner.Form.Name then
    Result := ProxyDesigner.Form
  else begin
    Component:= ProxyDesigner.Form.FindComponent(WrapperName);
    if Component<>nil then  Wrapper:= Component;
    Result := ProxyDesigner.Form.FindComponent(ComponentName);
  end;
end;

// Display component information at object inspector
// Wrapper: wrapper control for non visual component (wrapper =nil when visual component)
procedure TObjectInspector.DisplayProperty(Wrapper,Component:TComponent);
var
  Name:string;
  Control:TComponent;
begin
   if ProxyDesigner = nil then Exit;
   if Component <> nil then
   begin
      SetEditBounds(nil);   // hide object inspecotor controls for editing
      GetPropertyInfo(TObject(Component));
      if Wrapper <> nil then ProxyDesigner.SelectComponent(Wrapper)
      else ProxyDesigner.SelectComponent(Component);
      if Component is TForm then Name:= ProxyDesigner.Form.ClassName
      else Name:= Component.ClassName;
      SelectComponent:= Component;
      if Component is TWrapperControl then
      begin
         Control:= (Component as TWrapperControl).Component;
         Name:= Control.ClassName;
         ComponentList.ItemIndex:= GetItemIndex(Control);
      end
      else ComponentList.ItemIndex:= GetItemIndex(Component);
   end;
end;

procedure  TObjectInspector.EditorProperty;
begin
   if (PropertyEditor <> nil) then
   begin
       PropertyEditor.Edit;
       UpdateValue;
   end;
   SetPropertyValueName(PropertyEditor.GetValue);
end;

procedure TObjectInspector.PropSetValue(const Value: string);
// Ӽ  Value Ѵ.
begin
   if PropertyEditor <> nil then
   begin
      PropertyEditor.SetValue(Value);
      UpdateValue;
   end;
end;

procedure TObjectInspector.UpdateValue;
begin
end;

function TObjectInspector.GetPropValue(Info:PPropInfo):TStringList;
// Ӽ   Ǵ  ش.(ڿ)
var
   Data:PTypeData;
   I,MinVal,MaxVal: Integer;
   ValueList: TStringList;
   TypeInfo1 :PTypeInfo;
begin
   ValueList:= TStringList.Create;
   Data:= GetTypeData(Info^.PropType^);
   case Info^.PropType^.Kind of
        tkEnumeration:
        begin
           for I:= Data.MinValue to Data.MaxValue do
               ValueList.Add(GetEnumName(Info^.PropType^,I));
           end;
           tkSet:
           begin
               Data     := GetTypeData(Info^.PropType^);
               TypeInfo1:= Data^.CompType^;
               Data     := GetTypeData(TypeInfo1);
               MinVal   := Data^.MinValue;
               MaxVal   := Data^.MaxValue;
               for I:= MinVal to MaxVal do
                  ValueList.Add(GetEnumName(TypeInfo1,I));
            end;
   end;
   Result:= ValueList;
end;

procedure TObjectInspector.SetEditBounds(AControl : TWinControl);
// Ӽ type  Ӽ Է Ʈ Ѵ.
var
  Index: Integer;
begin
  // Ӽ  Ǵ  , Ӽ ޺ ڽ Ӽ ġ ߰,
  // ׷  ޺ ڽ  ʰ Ѵ.
  if AControl <> nil then with AControl do
  begin
    cbValue.Visible   := False;
    Browse.Visible    := False;
    edProperty.Visible:= False;
    cbEvent.Visible   := False;
    Visible := True;
    SetFocus;
    if AControl = cbValue then
    begin
     // cbValue.SetBounds(EditRect.Left+1,EditRect.Top,
     //            EditRect.Right-EditRect.Left+3,EditRect.Bottom - EditRect.Top);
      Index:= cbValue.Items.IndexOf(GetPropertyValueName);
      if Index<>-1 then cbValue.ItemIndex:= Index
      else cbValue.Text:= GetPropertyValueName;
    end
  {  else if AControl = edProperty then
    begin
      edProperty.SetBounds(EditRect.Left+1,EditRect.Top + 1,
                 EditRect.Right-EditRect.Left+3,EditRect.Bottom - EditRect.Top);
    end
    else if AControl = Browse then
    begin
      Browse.SetBounds(EditRect.Right-Browse.Width, EditRect.Top+1, Browse.Width, PropertyBox.ItemHeight - 2);
    end}
    else if AControl = cbEvent then
    begin
      cbEvent.SetBounds(EditRect.Left+1,EditRect.Top,
                 EditRect.Right-EditRect.Left+3,EditRect.Bottom - EditRect.Top);
      cbEvent.Width:= EventBox.ClientWidth - HalfWay;
      cbEvent.Text:= Copy(EventBox.Items[EventBox.ItemIndex], 21, 255);
    end;
  end
  else
  begin
     cbValue.Visible   := False;
     Browse.Visible    := False;
     edProperty.Visible:= False;
     cbEvent.Visible   := False;
  end;
end;

procedure TObjectInspector.ComboValueChange(Sender: TObject);
begin
   PropSetValue(cbValue.Text);
end;

procedure TObjectInspector.StringGrid2DblClick(Sender: TObject);
// ̺Ʈ  ҽ ڵ带 Ѵ.
var
   EventName: string;
   EventHandler:string;
begin
    EventName:= ExtractComponentName(ComponentList.text);
    EventHandler:= EventName;
    // ̺Ʈ ĸ͸ Ѵ.
    EventName:= EventName+'('+WriteMethodData(GetTypeData(PropertyEditor.GetPropType))+');';
    // ̺Ʈ ڵ鷯 ۼ ʾ ̺Ʈ ڵ鷯 ۼϰ, ڵ ⸦ ȰȭѴ.
end;

{ Get a value from the list of string values. }
procedure TObjectInspector.GetValueProc(const Value: string);
begin
   cbValue.Items.Add(Value);
end;

procedure TObjectInspector.GetEventValueProc(const Value: string);
begin
   cbEvent.Items.Add(Value);
end;

procedure TObjectInspector.PropertyBoxDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  sr,dr: TRect;
  PropName,PropValue:string;
begin
  with (Control as TListBox).Canvas do
  begin
    Brush.Color := PropertyBox.Color;          {Won't use Windows Selected color.}
    FillRect(Rect);

    // μ ׸
    if (odSelected in State) then Pen.Color := clBtnHighLight else {for 3D look}
      Pen.Color := clBtnShadow;
    Pen.Mode  := pmCopy;
    Pen.Width := 1;
    Pen.Style := psSolid;
    MoveTo(Rect.Left, Rect.Bottom-1);
    LineTo(Rect.Right, Rect.Bottom-1);

    // Item ߰ 巡׸   ׸
    if (odFocused in State) then
    begin
      Pen.Color := clBtnHighLight;
      MoveTo(HalfWay + 2, Rect.Top+1);
      LineTo(Halfway + 2, Rect.Bottom);

      Pen.Color := clBtnShadow;
      MoveTo(Halfway+1, Rect.Top+2);
      LineTo(Halfway+1, Rect.Bottom);

      MoveTo(Rect.Right, Rect.Top);
      LineTo(Rect.Left, Rect.Top);
      LineTo(Rect.Left, Rect.Bottom);

      Pen.Color := clBlack;
      MoveTo(Rect.Right-1, Rect.Top+1);
      LineTo(Rect.Left+1, Rect.Top+1);
      LineTo(Rect.Left+1, Rect.Bottom-1);
    end
    else
    begin
      Pen.Color := clBtnShadow;
      MoveTo(Halfway, Rect.Top+1);
      LineTo(Halfway, Rect.Bottom);

      Pen.Color := clBtnHighLight;
      MoveTo(HalfWay + 1, Rect.Top+1);
      LineTo(Halfway + 1, Rect.Bottom);
    end;

    SR.Left := Rect.Left+2 ;  SR.Right := HalfWay;
    SR.Top := Rect.Top+1;  SR.Bottom := Rect.Bottom-1;

    if (odFocused in State) then
    begin
      Inc(SR.Left);
      Inc(SR.Top);
      Inc(SR.Right);
    end;
    // Item Ӽ Ӽ 
    Font.Color := clBlack;
    setbkMode(PropertyBox.Canvas.Handle, Transparent);
    PropName:= Copy(PropertyBox.Items[Index],1,20);
    PropValue:= Copy(PropertyBox.Items[Index],21,255);
    if PropName[1] = '+' then
       TextRect(SR, Sr.Left, SR.Top+1, PropName )
    else  TextRect(SR, Sr.Left+10, SR.Top+1, PropName );
    Font.Color := clNavy;
    TextOut(HalfWay + 4, SR.Top+1, PropValue );

    DR.Left:= Rect.Left+2;  DR.Right := Rect.Left+13+2;  {DestRect}
    DR.Top := Rect.Top+1; DR.Bottom := Rect.Top+13+1;

    if (odSelected in State) then
    begin       { To give 3D look to inspector.}
      Inc(DR.Left); Inc(DR.Right);
      Inc(DR.Top); Inc(DR.Bottom);
      if edProperty.Visible then
      begin
        with Rect do
        begin
           if (Top <= 0) and (PropertyBox.ItemIndex <> 0) then
              edProperty.Visible:= False
           else if (Bottom > PropertyBox.Height) then
              edProperty.Visible:= False
           else edProperty.SetBounds(HalfWay+4, Top+2, Right-HalfWay, Bottom-Top);
        end;
      end
      else if cbValue.Visible then
      begin
      // PropertyBox ũѽ cbValue ġ Ѵ.
        with Rect do
        begin
           if (Top <= 0) and (PropertyBox.ItemIndex <> 0) then
              cbValue.Visible:= False
           else if (Bottom > PropertyBox.Height) then
              cbValue.Visible:= False
           else cbValue.SetBounds(HalfWay+4, Top+2, Right-HalfWay, Bottom-Top);
        end;
      end
      else if Browse.Visible then
      begin
        with Rect do
        begin
           if (Top <= 0) and (PropertyBox.ItemIndex <> 0) then
              Browse.Visible:= False
           else if (Bottom > PropertyBox.Height) then
              Browse.Visible:= False
           else Browse.SetBounds(Right-Browse.Width, Top+1, Browse.Width, PropertyBox.ItemHeight - 2);
        end;
      end
    end;
  end;
  if (not edProperty.Focused) and (odFocused in state) then
  begin
      edProperty.Visible:= False;
      with PropertyBox.Canvas do
      begin
         EditRect := PropertyBox.ItemRect(PropertyBox.ItemIndex);
         EditRect.Left := HalfWay + 4;
         Dec(EditRect.Bottom, 2);
         Inc(EditRect.Top,3);
         Brush.Color := clWhite;
         FillRect(EditRect);
         setbkColor(PropertyBox.Canvas.Handle, GetsysColor(color_HighLight));
         setbkMode(PropertyBox.Canvas.Handle, Opaque);
         Font.Color := clhighlightText;
         Canvas.Brush.Color := clHighlight;
         TextOut(EditRect.Left, EditRect.Top, PropValue);
      end;
  end;
  {if (odFocused in State) and (odselected in state) then
      (Control as TListbox).Canvas.DrawFocusRect(rect);}
end;

procedure TObjectInspector.PropertyBoxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  R,sr : TRect;
begin
  if Abs(X - Halfway) <= 3 then  SplitDrag := True
  else
  if (X >= EditRect.left) and (X <= EditRect.Right) and
     (y >= EditRect.Top) and (Y <= EditRect.Bottom) then
     begin
     PropertyBox.Cursor := crDefault;
    // SetEditor(PropertyList.Objects[PropertyBox.ItemIndex] as TPropertyEditor)
  end;
end;

procedure TObjectInspector.PropertyBoxMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  TempR : TRect;
  LB : TListBox;
begin
  if PageControl1.ActivePage = TabProperty then  Lb := PropertyBox
  else lb := EventBox;
  if SplitDrag then
  begin
    if X > Lb.ClientWidth - 20 then X := Lb.ClientWidth - 20;
    if X < 20 then X := 20;

    if Halfway < X then TempR:= Rect(Halfway, 0, lb.ClientWidth, lb.ClientHeight)
    else  TempR:= Rect(X, 0, lb.ClientWidth, lb.ClientHeight);
    HalfWay := X;

    InvalidateRect(lb.Handle, @TempR, False);
    InvalidateRect(lb.Handle, @EditRect, False);
    PostMessage(lb.Handle, WM_Paint, 0, 0);
    Exit;
  end;
  if Abs(x - Halfway) <= 3 then   lb.Cursor := crHSplit
  else
  if (X >= EditRect.left) and (X <= EditRect.Right) and
     (Y >= EditRect.Top) and (Y <= EditRect.Bottom) then
       lb.Cursor := crIBeam else lb.Cursor := crDefault;
end;

procedure TObjectInspector.PropertyBoxMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   SplitDrag := False;
end;

procedure TObjectInspector.FormShow(Sender: TObject);
begin
  Halfway := PropertyBox.Width div 2;
end;

procedure TObjectInspector.EventBoxDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  SR,DR: TRect;
  EventName,EventValue:string;
begin
  with (Control as TListBox).Canvas do
  begin
    Brush.Color := EventBox.Color;          {Won't use Windows Selected color.}
    FillRect(Rect);
    // μ ׸
    if (odSelected in State) then Pen.Color := clBtnHighLight else {for 3D look}
      Pen.Color := clBtnShadow;
    Pen.Mode  := pmCopy;
    Pen.Width := 1;
    Pen.Style := psSolid;
    MoveTo(rect.Left, Rect.Bottom-1);
    LineTo(rect.Right, Rect.Bottom-1);

    // Item ߰ 巡׸   ׸
    if (odSelected in State) then
    begin
      Pen.Color := clBtnHighLight;
      MoveTo(HalfWay + 2, Rect.Top+1);
      LineTo(Halfway + 2, Rect.Bottom);

      Pen.Color := clBtnShadow;
      MoveTo(Halfway+1, rect.Top+2);
      LineTo(Halfway+1, rect.Bottom);

      MoveTo(Rect.Right, Rect.Top);
      LineTo(Rect.Left, Rect.Top);
      LineTo(Rect.Left, Rect.Bottom);

      Pen.Color := clBlack;
      MoveTo(Rect.Right-1, Rect.Top+1);
      LineTo(Rect.Left+1, Rect.Top+1);
      LineTo(Rect.Left+1, Rect.Bottom-1);
    end
    else begin
      Pen.Color := clBtnShadow;
      MoveTo(Halfway, rect.Top+1);
      LineTo(Halfway, rect.Bottom);

      Pen.Color := clBtnHighLight;
      MoveTo(HalfWay + 1, Rect.Top+1);
      LineTo(Halfway + 1, Rect.Bottom);
    end;

    SR.Left := Rect.Left+2 ;  SR.Right := HalfWay;
    SR.Top := Rect.Top+1;  SR.Bottom := Rect.Bottom-1;

    if (odSelected in State) then
    begin
      Inc(SR.Left);
      Inc(SR.Top);
      Inc(SR.Right);
    end;
    // Item ̺Ʈ ̺Ʈ 
    Font.Color := clBlack;
    setbkMode(EventBox.Canvas.Handle, Transparent);
    EventName:= Copy(EventBox.Items[Index],1,20);
    EventValue:= Copy(EventBox.Items[Index],21,255);
    TextRect(SR, Sr.Left + 10, SR.Top, EventName);
    Font.Color := clNavy;
    TextOut(HalfWay + 4, SR.Top, EventValue );

    DR.Left:= Rect.Left+2;  DR.Right := Rect.Left+13+2;  {DestRect}
    DR.Top := Rect.Top+1; DR.Bottom := Rect.Top+13+1;

    if (odSelected in State) then
    begin       { To give 3D look to inspector.}
      Inc(DR.Left); Inc(DR.Right);
      Inc(DR.Top); Inc(DR.Bottom);
    end;
  end;

  if (not cbEvent.Focused) and (odselected in state) then
      with EventBox.Canvas do
      begin
         EditRect := EventBox.ItemRect(EventBox.ItemIndex);
         EditRect.Left := HalfWay + 2;
         Brush.Color := clWhite;
         Inc(EditRect.Top,4);
         Fillrect(EditRect);
         setbkColor(EventBox.Canvas.Handle, GetsysColor(color_HighLight));
         setbkMode(EventBox.Canvas.Handle, Opaque);
         Font.Color := clhighlightText;
         Canvas.Brush.Color := clHighlight;
         TextOut(EditRect.Left, EditRect.Top, EventValue);
      end;
  if (odFocused in State) and (odselected in state) then
      (Control as TListbox).Canvas.DrawFocusRect(Rect);
end;

procedure TObjectInspector.EventBoxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  P : TPoint;
begin
  if Abs(X - Halfway) <= 3 then  SplitDrag := True
  else
  if (X >= EditRect.Left) and (X <= EditRect.Right) and
     (y >= EditRect.Top) and (Y <= EditRect.Bottom) then
  begin
     P:= Point(X,Y);
     EventBox.Cursor := crDefault;
     MapWindowPoints(EventBox.Handle, cbEvent.Handle, P, 1);
     PostMessage(cbEvent.Handle, WM_LButtonDown, mk_lbutton, P.Y shl 16 + P.X);
  end;
end;

procedure TObjectInspector.EventBoxMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var
  TempR : TRect;
  LB : TListBox;
begin
  if PageControl1.ActivePage = TabProperty then  Lb := PropertyBox
  else lb := EventBox;
  if SplitDrag then
  begin
    if X > Lb.ClientWidth - 20 then X := Lb.ClientWidth - 20;
    if X < 20 then X := 20;

    if Halfway < X then TempR:= Rect(Halfway, 0, lb.ClientWidth, lb.ClientHeight)
    else  TempR:= Rect(X, 0, lb.ClientWidth, lb.ClientHeight);
    HalfWay := X;

    InvalidateRect(lb.Handle, @TempR, False);
    InvalidateRect(lb.Handle, @EditRect, False);
    PostMessage(lb.Handle, WM_Paint, 0, 0);
    Exit;
  end;
  if Abs(x - Halfway) <= 3 then   lb.Cursor := crHSplit
  else
  if (X >= EditRect.left) and (X <= EditRect.Right) and
     (Y >= EditRect.Top) and (Y <= EditRect.Bottom) then
       lb.Cursor := crIBeam else lb.Cursor := crDefault;
end;

procedure TObjectInspector.EventBoxMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   if SplitDrag then
   begin   // 巡װ  Ʈ ġ 
      cbEvent.Left   := EditRect.left;
      cbEvent.Top    := EditRect.Top;
      cbEvent.Width  := EditRect.Right - EditRect.Left;
      cbEvent.Height := EditRect.Bottom - EditRect.Top;
   end;
   SplitDrag := False;
end;

function TObjectInspector.GetPropertyName: string ;
// ListBox ItemIndex Ӽ ش.
begin
   Result:='';
   if PropertyBox.ItemIndex = -1 then Exit;
   Result:= Trim(Copy(PropertyBox.Items[PropertyBox.ItemIndex],1,20));
end;

function TObjectInspector.GetEventName: string ;
// ListBox ItemIndex ̺Ʈ ش.
begin
   Result:='';
   if EventBox.ItemIndex = -1 then Exit;
   Result:= Trim(Copy(EventBox.Items[EventBox.ItemIndex],1,20));
end;

function TObjectInspector.GetPropertyValueName: string ;
// ListBox ItemIndex Ӽ ش.
begin
   Result:='';
   if PropertyBox.ItemIndex = -1 then Exit;
   Result:= Trim(Copy(PropertyBox.Items[PropertyBox.ItemIndex],21,255));
end;

function TObjectInspector.GetEventValueName: string ;
// ListBox ItemIndex ̺Ʈ ش.
begin
   Result:='';
   if EventBox.ItemIndex = -1 then Exit;
   Result:= Trim(Copy(EventBox.Items[EventBox.ItemIndex],21,255));
end;

procedure TObjectInspector.SetPropertyValueName(Value:string) ;
// ListBox ItemIndex Ӽ Ѵ.
begin
   if PropertyBox.ItemIndex = -1 then Exit;
   with PropertyBox do
      Items[ItemIndex]:= Copy(Items[ItemIndex],1,20)+ Value;
end;

procedure TObjectInspector.PropertyBoxClick(Sender: TObject);
// Ŭ Ӽ Ӽ ⸦ Ѵ.
begin
   with PropertyList do
      if PropertyList.Count>0 then
         SetEditor(Objects[PropertyBox.ItemIndex] as TPropertyEditor)
      else SetEditor(nil);
end;

function TObjectInspector.GetPropertyBoxValue(DBName:string): string ;
// Ӽ Name Ӽ Ӽ ش.
var
   I:Integer;
   S:string;
begin
   Result:='';
   with PropertyBox do
   begin
      for I:=0 to Items.Count - 1 do
      begin
         S:= Trim(Copy(Items[I],1,20));
         if S = DBName then
         begin
            Result:= Trim(Copy(Items[I],21,255));
            Break;
         end;
      end;
   end;
end;

procedure TObjectInspector.PropertyBoxKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if Key = vk_return then
  begin
    Key := 0;
    exit;
  end;
  if Key =  VK_F1 then ShowHelp;
  if not (Key in [vk_up, vk_down, vk_prior, vk_next]) then
  begin
    edProperty.Left    := EditRect.Left;
    edProperty.Top     := EditRect.Top;
    edProperty.Width   := EditRect.Right - EditRect.Left;
    edProperty.Height  := EditRect.Bottom - EditRect.Top;
    edProperty.Visible := True;
    edProperty.SetFocus;
    edProperty.SelectAll;
    PostMessage(edProperty.Handle, WM_KeyDown, Key, 0);
    Key := 0;
  end;
end;

procedure TObjectInspector.EventBoxClick(Sender: TObject);
begin
   with EventList do
      if Count>0 then
         SetEditor(Objects[EventBox.ItemIndex] as TPropertyEditor)
      else  SetEditor(nil);
end;

// Ӽ  Ŭϴ ,  ʷ ٲٰ, Ӽ Ѵ.
// ListBox Style Ӽ csDropDown Ǿ ִ 쿡 
procedure TObjectInspector.cbValueDblClick(Sender: TObject);
begin
   with cbValue do begin
      if ItemIndex<0 then ItemIndex:=0
      else if ItemIndex=(Items.Count-1) then ItemIndex:=0
      else ItemIndex:=ItemIndex+1;
      cbValueChange(self);
   end;
end;

procedure TObjectInspector.BrowseClick(Sender: TObject);
begin
   EditorProperty;
end;

procedure TObjectInspector.edPropertyKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
   case Key of
     VK_DOWN:
        if PropertyBox.ItemIndex< (PropertyBox.Items.Count-1) then
        begin
           if edProperty.Modified then
           begin //Edit  Ǿ
              PropSetValue(edProperty.Text);
              with PropertyBox do
                 Items[ItemIndex]:= Format('%-20s',[GetPropertyName]) + edProperty.Text;
           end;
        end;
     VK_UP:
        if PropertyBox.ItemIndex >= 1 then
        begin
           if edProperty.Modified then
           begin //Edit  Ǿ
              PropSetValue(edProperty.Text);
              with PropertyBox do
                 Items[ItemIndex]:= Format('%-20s',[GetPropertyName]) + edProperty.Text;
           end;
        end;
     VK_F1:
        ShowHelp;
   end;
   if (Key in [vk_up, vk_down, vk_prior, vk_next]) then
   begin
      PropertyBox.SetFocus;
      PostMessage(PropertyBox.Handle, WM_KeyDown, Key, 0);
      Key := 0;
   end;
end;

procedure TObjectInspector.edPropertyKeyPress(Sender: TObject;
  var Key: Char);
begin
   if Key = #13 then
   begin
      PropertyBox.SetFocus;
      PropSetValue(edProperty.Text);
      with PropertyBox do
         Items[ItemIndex]:= Format('%-20s',[GetPropertyName]) + edProperty.Text;
   end;
end;

procedure TObjectInspector.cbValueChange(Sender: TObject);
begin
   PropSetValue(cbValue.Text);
   with PropertyBox do
       Items[ItemIndex]:= Format('%-20s',[GetPropertyName]) + cbValue.Text;
end;

procedure TObjectInspector.cbValueKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if Key = vk_Return then
   begin
      PropertyBox.SetFocus;
      Key := 0;
      Exit;
   end;
   if Key =  VK_F1 then ShowHelp;
   if (Key in [vk_up, vk_down, vk_prior, vk_next]) then
   begin
      PropertyBox.Setfocus;
      PostMessage(PropertyBox.Handle, WM_KeyDown, Key, 0);
      Key := 0;
   end;
end;

procedure TObjectInspector.cbValueDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
begin
  with (Control as TComboBox).Canvas do
  begin
    FillRect(Rect);
   // Font.Color := clNavy;
    TextOut(Rect.Left, Rect.Top, cbValue.Items[Index]);
  end;
end;

procedure TObjectInspector.FormActivate(Sender: TObject);
begin
  InitializeInspector;
  if ComponentList.ItemIndex = -1 then  ComponentList.ItemIndex:=0;
end;

// ο  ۼϰų  ̸ ȯ  Object Inspector 
//  ° ٽ д´.
procedure TObjectInspector.InitializeInspector;
var
  I:Integer;
begin
   if ProxyDesigner = nil then Exit;
   ComponentList.Clear;
   ComponentList.Items.Add(ProxyDesigner.Form.Name+':' +ProxyDesigner.Form.ClassName);
   with ProxyDesigner.Form do
   begin
    for I:=0 to  ComponentCount-1 do
        if not ProxyDesigner.IsDesignedComponent(Components[I]) then
           ComponentList.Items.Add(Components[I].Name+':'+Components[I].ClassName)
    end;
    ComponentList.ItemIndex:= GetItemIndex(SelectComponent);
   // ComponentList.ItemIndex:= -1;
end;

// ۳Ʈ Ͽ ۳Ʈ ϴ , ش ۳Ʈ ϰ Ӽ ش.
procedure TObjectInspector.ComponentListClick(Sender: TObject);
var
  Component:TComponent;
  Wrapper:TComponent;
begin
   Component := GetComponent(Wrapper);
   DisplayProperty(Wrapper,Component);
end;

procedure TObjectInspector.PropertyBoxDblClick(Sender: TObject);
var
  Po:TPoint;
  PropInfo:PPropInfo;
  PropName:string;
  Editor:TPropertyEditor;
begin
   GetCursorPos(Po);
   Po:= PropertyBox.ScreenToClient(Po);
   if Po.x < HalfWay then
   begin
      if PropertyBox.Items[PropertyBox.ItemIndex][1] = '+' then
      begin
         PropName:= Trim(Copy(PropertyBox.Items[PropertyBox.ItemIndex],2,20));
         PropertyBox.Items[PropertyBox.ItemIndex]:= '-' + PropName;
         //PropInfo:= GetPropInfo(SelectComponent.ClassInfo, PropName);
         //InsertPropInfo(PropInfo, SelectComponent);
         Editor:= TPropertyEditor(PropertyList.Objects[PropertyBox.ItemIndex]);
         if Editor <> nil then
            Editor.GetProperties(GetSubPropEditor);
      end
      else if PropertyBox.Items[PropertyBox.ItemIndex][1] = '-' then
      begin
         PropName:= Trim(Copy(PropertyBox.Items[PropertyBox.ItemIndex],2,20));
         PropertyBox.Items[PropertyBox.ItemIndex]:= '+' + PropName;
         PropInfo:= GetPropInfo(SelectComponent.ClassInfo, PropName);
         DeletePropInfo(PropInfo, SelectComponent);
      end;
   end;
end;

//cbValue ItemIndex Text  ε Ѵ.
// cbValue Style csDropDownList ߱ 
// cbValue.Text:= Text  ҿ  ̴.
procedure TObjectInspector.SetcbValueIndex(Text:string);
var
  Index:Integer;
begin
   Index:= cbValue.Items.IndexOf(Text);
   if Index<>-1 then cbValue.ItemIndex:= Index
   else cbValue.Text:= GetPropertyValueName;
end;

procedure TObjectInspector.ShowHelp;
var
  KeyWord:string;
begin
   KeyWord:= Trim(Copy(PropertyBox.Items[PropertyBox.ItemIndex],1,20));
   Application.HelpCommand(HELP_KEY,longint(KeyWord));
end;

function TObjectInspector.GetClassList(ClassName:string;CanParent:Boolean):string;
// ClassName  ۳Ʈ  ش.
var
  I:Integer;
  List:TStringList;
  CName, CType, S:string;
  Class1:TClass;
  CurComponent:TComponent;
begin
   Result:= '';
   List:= TStringList.Create;
   for I:= 0 to ComponentList.Items.Count - 1 do
   begin
      CName:= ComponentList.Items[I];
      CType:= ExtractComponentType(CName);
      if CanParent then
      begin
         Class1:= FindClass(ClassName);
         S:= ExtractComponentName(CName);
         CurComponent:= ProxyDesigner.Form.FindComponent(S);
         if (CurComponent is Class1 ) then List.Add(S);
      end
      else if CompareText(CType, ClassName) = 0 then
         List.Add(ExtractComponentName(CName));
   end;
   Result:= List.Text;
   List.Free;
end;

procedure TObjectInspector.GetPrpoertyItemList(ClassName:string;CanParent:Boolean);
// MainMenu, DataSource   Ӽ    ִ ׸ Ѵ.
// CanParent True  θ Ŭ Ѵ.
var
  ClassType:TClass;
begin
   ClassType:= FindClass(ClassName);
   cbValue.Items.Text:= GetClassList(ClassName, CanParent);
   SetEditBounds(cbValue);
end;

procedure TObjectInspector.GetDatabaseNameList;
var
   List:TStringList;
begin
  {$IFDEF DBVERSION}
   List:= TStringList.Create;
   Session.GetDatabaseNames(List);
   cbValue.Items.Assign(List);
   SetEditBounds(cbValue);
   List.Free;
   {$ENDIF}
end;

procedure TObjectInspector.GetTableNameList;
var
   List:TStringList;
   DBName:string;
begin
   List:= TStringList.Create;
   DBName:= GetPropertyBoxValue('DatabaseName');
   {$IFDEF DBVERSION}
   Session.GetTableNames(DBName,'', False, False, List);
   {$ENDIF}
   cbValue.Items.Assign(List);
   SetEditBounds(cbValue);
   List.Free;
end;


procedure TObjectInspector.HideItemClick(Sender: TObject);
begin
   Hide;
end;

procedure TObjectInspector.StayOnTopItemClick(Sender: TObject);
begin
   StayOnTopItem.Checked:= not StayOnTopItem.Checked;
   if StayOnTopItem.Checked then FormStyle:= fsStayOnTop
   else FormStyle:= fsNormal;
end;

procedure TObjectInspector.InformationItemClick(Sender: TObject);
begin
   with TRTTIForm.Create(self) do
   begin
      if SelectComponent <> nil then
      begin
         if PageControl1.ActivePage = TabProperty then
         begin
            Caption:= 'RunTime Type Information(RTTI) about '+ PropertyName + ' of '+ SelectComponent.Name;
            WriteTypeInfo(SelectComponent.ClassInfo, PropertyName, PropertyEditor);
         end
         else if PageControl1.ActivePage = TabEvent then
         begin
            Caption:= 'RunTime Type Information(RTTI) about '+ GetEventName + ' of '+ SelectComponent.Name;
            WriteTypeInfo(SelectComponent.ClassInfo, GetEventName, PropertyEditor);
         end;
      end;
      ShowModal;
      Free;
   end;
end;

procedure TObjectInspector.EditEventHandler(Index: Integer);
// ̺Ʈ Index° Ѵ.
begin
    PageControl1.ActivePage:= ObjectInspector.TabEvent;
    EventBox.ItemIndex:= Index;
    EventBoxClick(self);
    cbEventDblClick(self);
end;

procedure TObjectInspector.cbEventDblClick(Sender: TObject);
var
   EventName, Event: string;
   EventHandler:string;
   Editor: TPropertyEditor;
   Method: TMethod;

   procedure SetEventValue;
   var
     PropInfo: PPropInfo;
   begin
      PropInfo:= GetPropInfo(SelectComponent.ClassInfo, Event);
      if PropInfo <> nil then
         SetMethodProp(SelectComponent, PropInfo, Method);
   end;
   
begin
    Editor      := EventList.Objects[EventBox.ItemIndex] as TPropertyEditor;
    Event       := Trim(Copy(EventBox.Items[EventBox.ItemIndex], 1, 20));
    EventName   := ExtractComponentName(ComponentList.Text);
    EventName   := EventName + Copy(Event ,3 ,20);
    EventHandler:= EventName;
    // get event's parameters
    EventName   := EventName+'('+WriteMethodData(GetTypeData(PropertyEditor.GetPropType))+');';
    // ̺Ʈ ڵ鷯 ۼ ʾ ̺Ʈ ڵ鷯 ۼϰ, ڵ ⸦ ȰȭѴ.
    if not EditorForm.SetFocusEventHandler(EventName) then
       EditorForm.WriteEventCode(EventName);
    with EventBox do
       Items[ItemIndex]:=
          Format('%20s%s',[Copy(Items[ItemIndex],1,20),EventHandler]);
    Method:= ProxyDesigner.CreateMethod(EventHandler, GetTypeData(PropertyEditor.GetPropType));
    SetEventValue;
    PropSetValue(EventHandler);
end;

procedure TObjectInspector.cbEventKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if Key = vk_Return then
   begin
      EventBox.SetFocus;
      Key := 0;
      Exit;
   end;
   if Key =  VK_F1 then ShowHelp;
   if (Key in [vk_up, vk_down, vk_prior, vk_next]) then
   begin
      EventBox.Setfocus;
      PostMessage(EventBox.Handle, WM_KeyDown, Key, 0);
      Key := 0;
   end;
end;

function TObjectInspector.GetItemIndex(Component: TComponent): Integer;
var
   Name: string;
begin
   Result:= -1;
   if Component = nil then Exit;
   Name:= Component.ClassName;
   Result:= ComponentList.Items.IndexOf(Component.Name+':'+Name);
end;

procedure TObjectInspector.InsertIntoList(Item: string; LineNumber: Integer; Child: Boolean);
var
 CurrentItem : Integer;
 Added       : Boolean;
 Node        : TTreeNode;
begin
   Added := False;
   for CurrentItem := 0 to TreeView.Items.Count - 1 do
   begin
    if TreeView.Items[CurrentItem].Text = Item then // Procedure/function is in list
    begin
     TreeView.Items[CurrentItem].Data := Pointer(Linenumber); // Change Linenumber
     Added := True;
     break;
    end;
   end;
   if not added then // new procedure/function
   begin
    if child then // it is a procedure/function, so add node as child of topnode
    begin
     Node := TreeView.Items.AddChildObject(TreeView.TopItem, Item, Pointer(LineNumber));
     Node.ImageIndex := 1;
     Node.SelectedIndex := 2;
    end
    else // it is 'implementation', add it as first node
    begin
     Node := TreeView.Items.AddObject(TreeView.TopItem, Item, Pointer(LineNumber));
     Node.ImageIndex := 0;
     Node.SelectedIndex := 0;
    end;
    TreeView.TopItem.Expand(False);
   // TreeView.CustomSort(@CustomSortProc, 0); // sort the list
   end;
end;

procedure TObjectInspector.TreeViewDblClick(Sender: TObject);
var
  Node: TTreeNode;
begin
  if TreeView.Selected = nil then Exit;
  Node := TreeView.Selected;
  if Node <> nil then
  begin
    ActivePasEditor.TopLine := Integer(Node.Data) + 1; // Move procedure to top of editor
    ActivePasEditor.CaretY := Integer(Node.Data) + 1; // Move caretposition to top of editor
    ActivePasEditor.SetFocus;
  end;
end;

procedure TObjectInspector.PageControl1Change(Sender: TObject);
begin
   if PageControl1.ActivePage = TabCodeExplorer then
   begin
      FMainForm.ViewCodeExplorerItem.Checked:= True;
      ActivePasEditor.RefreshAllTokens;
   end;
end;

procedure TObjectInspector.AlphaSort1Click(Sender: TObject);
begin
   if TreeView.SortType = stText then TreeView.SortType:= stNone;
   TreeView.SortType:= stText;
end;

procedure TObjectInspector.LineSort1Click(Sender: TObject);
begin
   TreeView.SortType:= stNone;
   Treeview.Items.BeginUpdate;
   TreeView.CustomSort(@CustomSortProc, 0);
   TreeView.Items.EndUpdate;
end;

procedure TObjectInspector.ReFresh1Click(Sender: TObject);
begin
   TreeView.Items.BeginUpdate;
   TreeView.Items.Clear;
   ActivePasEditor.RefreshAllTokens;
   TreeView.Items.EndUpdate;
end;

procedure TObjectInspector.TreeViewChange(Sender: TObject;
  Node: TTreeNode);
var
  Node1: TTreeNode;
begin
  if TreeView.Selected = nil then Exit;
  Node1 := TreeView.Selected;
  if Node1 <> nil then
  begin
    StatusBar1.SimpleText := Format('%s %s %d', [Node1.Text, ':', Integer(Node1.Data)]);
  end;
end;

procedure TObjectInspector.cbEventClick(Sender: TObject);
var
  EventHandler: string;
begin
   EventHandler:= cbEvent.Text;
   with EventBox do
      Items[ItemIndex]:=
         Format('%20s%s',[Copy(Items[ItemIndex],1,20), EventHandler]);
   PropSetValue(EventHandler);
end;

end.


