unit UProject;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, {ToolWin,} Buttons, ExtCtrls;

type
  TProjectManager = class(TForm)
    StatusBar1: TStatusBar;
    ListView1: TListView;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    sbUpdate: TSpeedButton;
    sbOption: TSpeedButton;
    sbForm: TSpeedButton;
    sbUnit: TSpeedButton;
    sbDelete: TSpeedButton;
    sbAdd: TSpeedButton;
    procedure sbAddClick(Sender: TObject);
    procedure sbUnitClick(Sender: TObject);
    procedure sbFormClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure sbDeleteClick(Sender: TObject);
    procedure sbOptionClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure GetProjectInfo;
  end;

var
  ProjectManager: TProjectManager;

implementation

uses MainForm, utils, Uconst, UProOption;

{$R *.DFM}

// Ʈ ҽ ش Ʈ ߰Ѵ.
procedure TProjectManager.sbAddClick(Sender: TObject);
begin
    if OpenDialog1.Execute then begin
       ProjectInfo.UnitItems.Add(GetNetFileName(OpenDialog1.FileName));
       ProjectInfo.FormItems.Add('Test');
       ProjectInfo.InsertProjectCode(GetNetFileName(OpenDialog1.FileName),'Test');
       GetProjectInfo;
    end;
end;

procedure TProjectManager.GetProjectInfo;
var
   NewItem:TListItem;
   I:integer;
begin
    with ListView1 do begin
       Items.Clear;
       for I:=0 to ProjectInfo.UnitItems.Count-1 do begin
          NewItem:=Items.Add;
          with NewItem do begin
             Caption:= GetNetFileName(ProjectInfo.UnitItems[I]);   // Ʈ 
             SubItems.Add(GetNetFileName(ProjectInfo.FormItems[I])); //  
          end;
       end;
   end;
end;

procedure TProjectManager.sbUnitClick(Sender: TObject);
begin
   if ListView1.Selected = nil then Exit;
   Screen.Cursor:= crHourGlass;
   FMainForm.OpenFile(ProjectInfo.ProjectPath+ListView1.Selected.Caption+'.pas');
   ModalResult:= mrOK;
   Screen.Cursor:=crDefault;
end;

procedure TProjectManager.sbFormClick(Sender: TObject);
begin
   if ListView1.Selected = nil then Exit;
   Screen.Cursor:= crHourGlass;
   FMainForm.OpenFile(ProjectInfo.ProjectPath+ListView1.Selected.Caption+'.pas');
   ModalResult:= mrOK;
   Screen.Cursor:=crDefault;
end;

procedure TProjectManager.FormCreate(Sender: TObject);
begin
    Statusbar1.SimpleText:=ProjectInfo.ProjectName+','+
          IntToStr(ProjectInfo.UnitItems.Count)+'Ʈ';
end;

// Ʈ ҽ ش Ʈ Ѵ,
procedure TProjectManager.sbDeleteClick(Sender: TObject);
begin
   with ListView1 do begin
      if SelCount>0 then begin
          ProjectInfo.DeleteProjectCode(Selected.Caption);
          Items.Delete(Selected.Index);
      end;
   end;
end;

procedure TProjectManager.sbOptionClick(Sender: TObject);
begin
    CreateShowModal(TProjOption);
    ModalResult:=mrOK;
end;

end.
