unit utype;

interface

uses
   Windows,Classes, SysUtils, Messages, Controls, Forms,Graphics, TypInfo,
   DsgnIntf,Proxy,buttons,menus,clipbrd, comobj, stdctrls;

{$Include handel.inc}

type
  TProjectState = (psNone, psNew,psOpen,psSave,psChange);

  TMenuItemButton = class(TSpeedButton)
  end;

  TProjectInfo = class(TComponent)
  private
     fProjectName,fProjectPath:string;
     fProjectState : TProjectState;
     fUnitItems:TStringList;
     fFormItems:TStringList;
     fProjectSource:TStringList;
     fMainForm:string;
     fTitle:string;
     fHelpFile:string;
     function  GetStrValue(const Str:string):string;
     procedure SetTitle(TitleName:string);
     procedure SetHelpFile(HelpName:string);
     function  GetStrPos(const Str:string):Integer;
     procedure GetMainForm;
     procedure SetProjectName(ProjName:string);
     procedure SetProjectInfo;
  protected
     procedure SetUnitItems(Value:TStringList);
     procedure SetFormItems(Value:TStringList);
  public
     constructor Create(AOwner: TComponent); override;
     destructor Destroy; override;
     procedure RenameUnit(OldName,NewName:string);
     procedure UpdateProject(Sender:TObject);
     function GetUniqueUnitName:string;
     function GetUniqueFormName:string;
     procedure NewForm(var FormName, UnitName:string);
     procedure CreateDefaultProject;
     procedure InsertProjectCode(const UnitName,FormName:string);
     procedure DeleteProjectCode(const UnitName:string);
     property HelpFile : string read fHelpFile write SetHelpFile;
     property ProjectName : string read fProjectName write SetProjectName;
     property MainForm : string read fMainForm write fMainForm;
     property ProjectPath : string read fProjectPath write fProjectPath;
     property ProjectState : TProjectState read fProjectState write fProjectState;
     property UnitItems : TStringList read fUnitItems write SetUnitItems;
     property FormItems : TStringList read fFormItems write SetFormItems;
     property ProjectSource : TStringList read fProjectSource write fProjectSource;
     property Title : string read fTitle write SetTitle;
  end;

{ Expand the SetDesiging method of a component. This method
  is protected, but casting the component to TExposeComponent
  allows other objects to put the component into design mode.
  This is important for the component form. }
type
  TExposeComponent = class(TComponent)
  public
    procedure SetDesigning(Value: Boolean);
  end;

  TUndoType = (utNone, utCut, utPaste, utDelete);

  TUndoList = class
  private
    fList: TList;
    fCanUndo: Integer;
    fOwner: TForm;
    fUndoLocked: Boolean;
    function GetCanUndo: Integer;
  protected
    procedure RemoveChange(index: Integer);
  public
    constructor Create;
    destructor Destroy; override;
    procedure AddChange(ChangeReason: TUndoType; ChangeList: string);
    procedure ClearList;
    procedure LockUndo;
    procedure UnLockUndo;
    property CanUndo: Integer read GetCanUndo;
  end;

  {$IFDEF DELPHI3}   // Delphi 3
  TProxyDesigner = class(TFormDesigner)
  private
    FMethods: TStrings;   { Refers to the method list in ComponentForm. }
    FGrabHandles: TGrabHandles;
    FPoint:TPoint;
    FGrabList: TList;  //  ۳Ʈ ǥϱ   Grab 
    FSelectList: TList;  //  ۳Ʈ  ϱ  List
    FMultiSelected: Boolean;
    FControlPressed:Boolean;
    FComponentList: TComponentList;
    FUndoList: TUndoList;
    function  GetFocusedControl(Msg: TMsg): TControl;
    procedure FindNextControl;
    procedure ProcessMouseDown(Sender:TControl;Message:TMessage);
    procedure ProcessRMouseDown(Sender:TControl;Message:TMessage);
    procedure ProcessMouseMove(Sender:TControl;Message:TMessage);
    procedure ProcessDblClick(Sender:TControl;Message:TMessage);
    procedure ProcessMouseUp(Sender:TControl;Message:TMessage);
    procedure ProcessKeyDown(Message:TMessage);
    procedure ProcessKeyUp(Message:TMessage);
    procedure AddComponentList(Component:TComponent);
    procedure DeleteComponentList(Component:TComponent);
    procedure DeleteControl(Control: TControl;Next:Boolean);
    procedure ReaderSetName(Reader: TReader; Component: TComponent;var Name: string);
    procedure ComponentRead(Component: TComponent);
    procedure ClearGrabHandles;
    function  IsSelected(Control:TControl):Boolean;
    procedure MoveControl(Key:Word);
  public
    constructor Create(Owner:TForm);
    destructor Destroy; override;
    function  IsDesignMsg(Sender: TControl; var Message: TMessage): Boolean; override;
    procedure Modified; override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure PaintGrid; override;
    procedure ValidateRename(AComponent: TComponent;const CurName, NewName: string); override;
    function  CreateMethod(const Name: string; TypeData: PTypeData): TMethod; override;
    function  GetMethodName(const Method: TMethod): string; override;
    procedure GetMethods(TypeData: PTypeData; Proc: TGetStrProc); override;
    function  GetPrivateDirectory: string; override;
    function  MethodExists(const Name: string): Boolean; override;
    procedure RenameMethod(const CurName, NewName: string); override;
    procedure ShowMethod(const Name: string); override;
    procedure SelectComponent(Instance: TPersistent); override;
    function  GetComponentName(Component: TComponent):string; override;
    function  CreateComponent(ComponentClass: TComponentClass;Parent:TComponent;
              Left,Top,Width,Height:Integer):TComponent;override;
    { Easy access to the list of methods. }
    property  Methods: TStrings read fMethods;
    function  MethodFromAncestor(const Method: TMethod): Boolean; override;
    function  UniqueName(const BaseName:string):string;override;
    procedure GetSelections(List: TComponentList); override;
    procedure SetSelections(List: TComponentList); override;
    procedure GetComponentNames(TypeData: PTypeData; Proc: TGetStrProc); override;
    function  GetComponent(const Name: string): TComponent; override;
    function  GetObject(const Name: string): TPersistent; override;
    function  GetObjectName(Instance: TPersistent): string; override;
    procedure GetObjectNames(TypeData: PTypeData; Proc: TGetStrProc); override;
   // function IsComponentLinkable(Component: TComponent): Boolean; override;
   // procedure MakeComponentLinkable(Component: TComponent); override;
    function  GetRoot: TComponent; override;
    procedure Revert(Instance: TPersistent; PropInfo: PPropInfo); override;
    function  GetIsDormant: Boolean; override;
    function  HasInterface: Boolean; override;
    function  HasInterfaceMember(const Name: string): Boolean; override;
    procedure AddInterfaceMember(const MemberText: string); override;

    procedure CopyComponent;
    procedure UndoComponent;
    procedure CutComponent;
    procedure PasteComponent;
    procedure GetComponentList;
    procedure DeleteSelectList;
    procedure ClearSelectList;
    procedure UpdateGrabHandle;
    procedure SelectAll;
    procedure SetProxyForm(Value: TCustomForm);
    procedure CreateMenuItemComponent(Component: TComponent);
    function  CreateWrapperComponent(Component: TComponent;Left,Top:Integer):TComponent;
    function  CreatePopupMenu : TPopupMenu;
    function  IsDesignedComponent(Component: TComponent): Boolean;
    property  ComponentList: TComponentList read FComponentList write FComponentList;
    property  GrabList:TList read fGrabList write fGrabList;
    property  MultiSelected:Boolean read FMultiSelected;
    property  SelectList:TList read fSelectList write fSelectList;
  end;
  {$ENDIF}

  {$IFDEF DELPHI4}    // Delphi 4
  TProxyDesigner = class(TComObject, IFormDesigner)
  private
    fMethods: TStrings;   { Refers to the method list in ComponentForm. }
    fGrabHandles: TGrabHandles;
    fPoint:TPoint;
    fGrabList: TList;  //  ۳Ʈ ǥϱ   Grab 
    fSelectList: TList;  //  ۳Ʈ  ϱ  List
    fMultiSelected: Boolean;
    fControlPressed:Boolean;
    FComponentList: TComponentList;
    FForm: TCustomForm;
    FUndoList: TUndoList;
    function  GetFocusedControl(Msg: TMsg): TControl;
    procedure FindNextControl;
    procedure ProcessMouseDown(Sender:TControl;Message:TMessage);
    procedure ProcessRMouseDown(Sender:TControl;Message:TMessage);
    procedure ProcessMouseMove(Sender:TControl;Message:TMessage);
    procedure ProcessDblClick(Sender:TControl;Message:TMessage);
    procedure ProcessMouseUp(Sender:TControl;Message:TMessage);
    procedure ProcessKeyDown(Message:TMessage);
    procedure ProcessKeyUp(Message:TMessage);
    procedure AddComponentList(Component:TComponent);
    procedure DeleteControl(Control: TControl;Next:Boolean);
    procedure ReaderSetName(Reader: TReader; Component: TComponent;var Name: string);
    procedure ComponentRead(Component: TComponent);
    procedure ClearGrabHandles;
    function  IsSelected(Control:TControl):Boolean;
    procedure MoveControl(Key:Word);
    procedure AddInterfaceMember(const MemberText: string);
  protected
    function GetCustomForm: TCustomForm;
    procedure SetCustomForm(Value: TCustomForm);
    procedure DeleteComponentList(Component:TComponent);
  public
    constructor Create(Owner:TForm);
    destructor Destroy; override;

    // IDesigner interface methods
    function  IsDesignMsg(Sender: TControl; var Message: TMessage): Boolean;
    procedure PaintGrid;
    function  GetIsControl: Boolean;
    procedure SetIsControl(Value: Boolean);
    procedure ValidateRename(AComponent: TComponent; const CurName, NewName: string);
    procedure Modified;
    // Notification  򸻿 ߸ Ǿ 
    // procedure Notification(AComponent: TComponent; Operation: TOperation);
    procedure Notification(AnObject: TPersistent; Operation: TOperation);
    property  Form: TCustomForm read GetCustomForm write SetCustomForm;

    // IFormDesigner interface methods
    function  CreateMethod(const Name: string; TypeData: PTypeData): TMethod;
    function  GetMethodName(const Method: TMethod): string;
    procedure GetMethods(TypeData: PTypeData; Proc: TGetStrProc);
    function  GetPrivateDirectory: string;
    procedure GetSelections(const List: IDesignerSelections);
    function  MethodExists(const Name: string): Boolean;
    procedure RenameMethod(const CurName, NewName: string);
    procedure SelectComponent(Instance: TPersistent);
    procedure SetSelections(const List: IDesignerSelections);
    procedure ShowMethod(const Name: string);
    function  UniqueName(const BaseName: string): string;
    procedure GetComponentNames(TypeData: PTypeData; Proc: TGetStrProc);
    function  GetComponent(const Name: string): TComponent;
    function  GetComponentName(Component: TComponent): string;
    function  GetObject(const Name: string): TPersistent;
    function  GetObjectName(Instance: TPersistent): string;
    procedure GetObjectNames(TypeData: PTypeData; Proc: TGetStrProc);
    function  MethodFromAncestor(const Method: TMethod): Boolean;
    function  CreateComponent(ComponentClass: TComponentClass; Parent: TComponent;
              Left, Top, Width, Height: Integer): TComponent;
    function  IsComponentLinkable(Component: TComponent): Boolean;
    procedure MakeComponentLinkable(Component: TComponent);
    function  GetRoot: TComponent;
    procedure Revert(Instance: TPersistent; PropInfo: PPropInfo);
    function  GetIsDormant: Boolean;
    function  HasInterface: Boolean;
    function  HasInterfaceMember(const Name: string): Boolean;
    procedure AddToInterface(InvKind: Integer; const Name: string; VT: Word;
      const TypeInfo: string);
    procedure GetProjectModules(Proc: TGetModuleProc);
    function  GetAncestorDesigner: IFormDesigner;
    function  IsSourceReadOnly: Boolean;
    property  IsDormant: Boolean read GetIsDormant;
    property  AncestorDesigner: IFormDesigner read GetAncestorDesigner;

    // TProxyDesigner methods
    procedure SetSelectionList(List: TComponentList);
    procedure CopyComponent;
    procedure UndoComponent;
    procedure CutComponent;
    procedure PasteComponent;
    procedure GetComponentList;
    procedure DeleteSelectList;
    procedure ClearSelectList;
    procedure UpdateGrabHandle;
    procedure SelectAll;
    procedure SetProxyForm(Value: TCustomForm);
    function  CreateWrapperComponent(Component: TComponent;Left,Top:Integer):TComponent;
    function  CreatePopupMenu : TPopupMenu;
    function  IsDesignedComponent(Component: TComponent): Boolean;
    procedure CreateMenuItemComponent(Component: TComponent);
    property  ComponentList: TComponentList read FComponentList write FComponentList;
    property  GrabList:TList read fGrabList write fGrabList;
    property  MultiSelected:Boolean read fMultiSelected;
    property  SelectList:TList read fSelectList write fSelectList;
    property  Methods: TStrings read fMethods;
  end;
  {$ENDIF}


implementation

uses
  WinTypes,Editor,ObjectInspec,MainForm,Dialogs,uconst, utils, compedit;

procedure SetBuffer(Format: Word; var Buffer; Size: Integer);
var
  Data: THandle;
  DataPtr: Pointer;
begin
   ClipBoard.Open;
   try
     Data := GlobalAlloc(GMEM_MOVEABLE, Size);
     try
       DataPtr := GlobalLock(Data);
       try
         Move(Buffer, DataPtr^, Size);
         ClipBoard.Clear;
         SetClipboardData(Format, Data);
       finally
         GlobalUnlock(Data);
       end;
     except
       GlobalFree(Data);
       raise;
     end;
   finally
     ClipBoard.Close;
   end;
end;

procedure GetNearestGridPoint(Point1: TPoint; var Point2: TPoint);
// Grid Point1   ׸ ǥ Point2 Ѱش.
var
  GridX, GridY, PoX, PoY, X, Y: Integer;
begin
   Point2:= Point1;
   GridX := IniFile.ReadInteger('SYSTEM','GridSizeX',8);
   GridY := IniFile.ReadInteger('SYSTEM','GridSizeY',8);
   PoX   := Point1.X;
   PoY   := Point1.Y;
   X     := (PoX div GridX) + 1;
   Y     := (PoY div GridY) + 1;
   Point2:= Point(X * GridX, Y * GridY);
end;

{TProjectInfo}
constructor TProjectInfo.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
   fUnitItems            := TStringList.Create;
   fFormItems            := TStringList.Create;
   fProjectSource        := TStringList.Create;
   ProjectSource.OnChange:= UpdateProject;
end;

destructor TProjectInfo.Destroy;
begin
   fUnitItems.Free;
   fFormItems.Free;
   fProjectSource.Free;
   inherited Destroy;
end;

procedure TProjectInfo.SetUnitItems(Value: TStringList);
begin
   fUnitItems.Assign(Value);
end;

procedure TProjectInfo.SetFormItems(Value: TStringList);
begin
   fUnitItems.Assign(Value);
end;

procedure TProjectInfo.GetMainForm;
var
  I,Pos1,Pos2:Integer;
begin
   I:=GetStrPos('Application.CreateForm');
   if I<>-1 then
   begin
      Pos1:= Pos(',',ProjectSource[I]);
      Pos2:= Pos(')',ProjectSource[I]);
      if Pos1>0 then fMainForm:=Trim(Copy(ProjectSource[I],Pos1+1,Pos2-Pos1-1));
   end;
end;

procedure TProjectInfo.UpdateProject(Sender:TObject);
var
   I:Integer;
begin
   for I:=0 to ProjectSource.Count-1 do
   begin
      if Pos('Application.Title',ProjectSource[I])>0 then  fTitle:=GetStrValue(ProjectSource[I]);
      if Pos('Application.HelpFile',ProjectSource[I])>0 then  fHelpFile:=GetStrValue(ProjectSource[I]);
   end;
   GetMainForm;
end;

// Set project name to ProjName
procedure TProjectInfo.SetProjectName(ProjName:string);
var
  Path: string;
begin
   fProjectName:= ProjName;
   Path:= ExtractFilePath(ProjName);
   if (ProjName = '') or (Path = '') or (not FileExists(ProjName)) then
   begin
      UnitItems.Clear;
      FormItems.Clear;
      CreateDefaultProject;
   end
  { else if not FileExists(ProjName) then
   begin
      UnitItems.Clear;
      FormItems.Clear;
      CreateDefaultProject;
   end}
   else
   begin
      SetProjectInfo;
      fProjectSource[0]:= Format('%s %s;',['program',GetNetFileName(ProjName)]);
   end;
end;

procedure TProjectInfo.RenameUnit(OldName,NewName:string);
var
  I:Integer;
  S,S1,S2:string;
begin
   I:= GetStrPos(OldName);
   if I = -1 then Exit;
   S1:= GetNetFileName(OldName);
   S2:= GetNetFileName(NewName);
   S := ProjectSource[I];
   S := ReplaceStr(S, S1, S2);
   S := ReplaceStr(S, OldName, NewName);
   ProjectSource[I]:= S;
end;

// Ʈ ҽ ڿ Ҵ (̸) ش.
function TProjectInfo.GetStrValue(const Str:string):string;
var
  Pos1,Pos2:Integer;
  S:string;
begin
   Pos1  := Pos(':=',Str);
   Pos2  := Pos(';',Str);
   S     := Trim(Copy(Str,Pos1+2,Pos2-Pos1-2));
   Result:= Copy(S,2,Length(S)-2);
end;

procedure TProjectInfo.SetTitle(TitleName:string);
var
   I:Integer;
begin
   I:= GetStrPos('Application.Title');
   if I<>-1 then
   begin
      ProjectSource[I]:='  Application.Title :='+''''+TitleName+''''+';';
      ProjectSource.SaveToFile(ProjectName);
      Exit;
   end;
   I:= GetStrPos('Application.Initialize;');
   if I= -1 then Exit;
   ProjectSource.Insert(I+1,'  Application.Title :='+''''+TitleName+''''+';');
   ProjectSource.SaveToFile(ProjectName);
end;

procedure TProjectInfo.SetHelpFile(HelpName:string);
var
   I:Integer;
begin
   I:=GetStrPos('Application.HelpFile');
   if I<>-1 then
   begin
      ProjectSource[I]:='  Application.HelpFile :='+''''+HelpName+''''+';';
      ProjectSource.SaveToFile(ProjectName);
      Exit;
   end;
   I:= GetStrPos('Application.Initialize;');
   if I= -1 then Exit;
   ProjectSource.Insert(I+1,'  Application.HelpFile :='+''''+HelpName+''''+';');
   ProjectSource.SaveToFile(ProjectName);
end;

// Ʈ ҽ Ư ڿ ִ  ˷ش.
function TProjectInfo.GetStrPos(const Str:string):Integer;
var
  I:Integer;
begin
   Result:=-1;
   for I:=0 to ProjectSource.Count-1 do
       if Pos(Str,ProjectSource[I])>0 then
       begin
          Result:=I;
          Exit;
       end;
end;

procedure TProjectInfo.SetProjectInfo;
// Ʈ   Ѵ.
var
   txtFile:TextFile;
   txtLine:string;
   NamePos,FormPos,FormEndPos:integer;
begin
   if not FileExists(fProjectName) then Exit;
   AssignFile(txtFile,fProjectName);
   Reset(txtFile);
   UnitItems.Clear;
   FormItems.Clear;
   ProjectPath:= ExtractFilePath(fProjectName);
   while not EOF(txtFile) do
   begin
      Readln(txtFile,txtLine);
      if Pos('{$R',txtLine)>0 then Break;   // Ʈ   о 
      NamePos:=Pos(' in',txtLine);           // Ʈ   ġ
      if NamePos>0 then
      begin
         FormPos:=Pos('{',txtLine);         //   ġ
         FormEndPos:=Pos('}',txtLine);      //    ġ
         UnitItems.Add(ProjectPath+Trim(Copy(txtLine,1,NamePos-1)+'.pas'));   // Ʈ 
         FormItems.Add(Copy(txtLine,FormPos+1,FormEndPos-FormPos-1)); //  
      end;
   end;
   CloseFile(txtFile);
   ProjectInfo.ProjectSource.LoadFromFile(ProjectName);
   ProjectInfo.UpdateProject(self);
   ProjectInfo.ProjectState:= psOpen;
end;

function TProjectInfo.GetUniqueUnitName:string;
// Ʈ  Ʈ ̸ ش.
var
   I,Count:Integer;
begin
   Result:='Unit1.pas';
   Count:=1;
   if UnitItems.Count<1 then Exit;
   for I:=0 to UnitItems.Count-1 do
   begin
      if Pos('Unit',UnitItems[I])>0 then Inc(Count);
   end;
   Result:='Unit'+IntToStr(Count)+'.pas';
end;

function TProjectInfo.GetUniqueFormName:string;
var
   I,Count:Integer;
begin
   Result:='Form1.dfm';
   Count:=1;
   if FormItems.Count<1 then Exit;
   for I:=0 to FormItems.Count-1 do
   begin
      if Pos('Form',FormItems[I])>0 then Inc(Count);
   end;
   Result:='Form'+IntToStr(Count)+'.dfm';
end;

procedure TProjectInfo.NewForm(var FormName, UnitName:string);
// Add New Form to Project
begin
   UnitName:= ProjectInfo.ProjectPath + GetUniqueUnitName;
   FormName:= GetUniqueFormName;
   UnitItems.Add(UnitName);
   FormItems.Add(ProjectInfo.ProjectPath+FormName);
   ProjectState:= psChange;
end;

procedure TProjectInfo.CreateDefaultProject;
//  Create default project source code
begin
   fProjectSource.Clear;
   with fProjectSource do
   begin
      Add(Format('%s %s;',['program','Project1']));
      Add(' ');
      Add('uses');
   //   Add(' ');
      Add('  Forms,');
   //   Add(Format('%s %s',['  Unit1 in','''Unit1.pas'' {Form1};']));
   //   Add(' ');
      Add('{$R *.RES}');
      Add(' ');
      Add('begin');
      Add('  Application.Initialize;');
      Add('  Application.CreateForm(TForm1,Form1);');
      Add('  Application.Run;');
      Add('end.');
   end;
end;

procedure TProjectInfo.InsertProjectCode(const UnitName,FormName:string);
// Insert unit to project source
var
   I: Integer;
   Temp:string;
begin
   for I:=0 to ProjectSource.Count-1 do
   begin
      if Pos('{$R *.RES}',ProjectSource[I])>0 then Break;
   end;
   //  Ʈ 𿡼 ';' ϰ , ',' ü
   Temp:=Copy(ProjectSource[I-1],1,Length(ProjectSource[I-1])-1);
   ProjectSource[I-1]:=Temp+',';
   ProjectSource.Insert(I ,Ident+GetNetFileName(UnitName)+' in '+''''+
       ExtractFileName(UnitName)+''''+' {'+GetNetFileName(FormName)+'};');
end;

procedure TProjectInfo.DeleteProjectCode(const UnitName:string);
// Delete unit from project source
var
   I: Integer;
   Temp:string;
begin
   for I:=0 to ProjectSource.Count-1 do
   begin
      if Pos(UnitName,ProjectSource[I])>0 then Break;
   end;
   ProjectSource.Delete(I);
end;

{TExposeComponent}
procedure TExposeComponent.SetDesigning(Value: Boolean);
begin
   inherited SetDesigning(Value);
end;

{TProxyDesigner}
constructor TProxyDesigner.Create(Owner:TForm);
begin
   FGrabList     := TList.Create;
   FMethods      := TStringList.Create;
   FSelectList   := TList.Create;
   FComponentList:= TComponentList.Create;
   FUndoList     := TUndoList.Create;
   Form:= Owner;
   {$IFDEF DELPHI4}
   FForm:= Owner;
   {$ENDIF}
end;

destructor TProxyDesigner.Destroy;
begin
   FGrabList.Free;
   FSelectList.Free;
   FComponentList.Free;
   FMethods.Free;
   FUndoList.Free;
   inherited;
end;

procedure TProxyDesigner.Modified;
begin
  // ProjectInfo.ProjectState := psChange;
   FMainForm.UpdateControl(psChange);
end;

procedure TProxyDesigner.AddInterfaceMember(const MemberText: string);
begin
end;

{$IFDEF DELPHI3}
procedure TProxyDesigner.GetSelections(List: TComponentList);
begin
end;

procedure TProxyDesigner.SetSelections(List: TComponentList);
var
  I: Integer;
begin
   ClearSelectList;
   if List.Count > 1 then FMultiSelected:= True;
   for I:= 0 to List.Count - 1 do
      SelectComponent(List[I]);
   FMultiSelected:= False;
end;

procedure TProxyDesigner.Notification(AComponent: TComponent;
                                      Operation: TOperation);
begin
  { case Operation of
      opInsert:
      begin
        if (AComponent is TGrabHandle) then Exit;
        AddComponentList(AComponent);
      end;
      opRemove:
      begin
        if (AComponent is TGrabHandle) then Exit;
        DeleteComponentList(AComponent);
       // GetComponentList;
      end;
   end;}
end;

{$ENDIF}

procedure TProxyDesigner.DeleteComponentList(Component:TComponent);
begin
   GetComponentList;
end;

procedure TProxyDesigner.GetComponentNames(TypeData: PTypeData; Proc: TGetStrProc);
begin
end;

function TProxyDesigner.GetComponent(const Name: string): TComponent;
begin
   Result:= Form.FindComponent(Name);
end;

function TProxyDesigner.GetObject(const Name: string): TPersistent;
begin
   Result:= nil;
end;

function TProxyDesigner.GetComponentName(Component:TComponent):string;
begin
   Result:=Component.Name;
end;

function TProxyDesigner.GetObjectName(Instance: TPersistent): string;
begin
   Result:= Instance.ClassName;
end;

procedure TProxyDesigner.GetObjectNames(TypeData: PTypeData; Proc: TGetStrProc);
begin
end;

{$IFDEF DELPHI4}
function TProxyDesigner.GetCustomForm: TCustomForm;
begin
   Result:= FForm;
end;

procedure TProxyDesigner.SetCustomForm(Value: TCustomForm);
begin
   FForm:= Value;
   FMethods.Clear;
end;

function TProxyDesigner.GetIsControl: Boolean;
begin
   Result:= False;
end;

procedure TProxyDesigner.SetIsControl(Value: Boolean);
begin
end;

procedure TProxyDesigner.Notification(AnObject: TPersistent; Operation: TOperation);
begin
   case Operation of
      opInsert:
      begin
        if (AnObject is TGrabHandle) then Exit;
        AddComponentList(TComponent(AnObject));
      end;
      opRemove:
      begin
        if (AnObject is TGrabHandle) then Exit;
        DeleteComponentList(TComponent(AnObject));
      end;
   end;
end;

procedure TProxyDesigner.GetSelections(const List: IDesignerSelections);
begin
end;

procedure TProxyDesigner.SetSelections(const List: IDesignerSelections);
var
  I: Integer;
begin
  ClearSelectList;
  if List.Count > 1 then FMultiSelected:= True;
  for I:= 0 to List.Count - 1 do
     SelectComponent(TPersistent(List[I]));
  FMultiSelected:= False;
end;

function TProxyDesigner.IsComponentLinkable(Component: TComponent): Boolean;
begin
   Result:= False;
end;

procedure TProxyDesigner.MakeComponentLinkable(Component: TComponent);
begin
end;

procedure TProxyDesigner.AddToInterface(InvKind: Integer; const Name: string; VT: Word;
   const TypeInfo: string);
begin
end;

procedure TProxyDesigner.GetProjectModules(Proc: TGetModuleProc);
begin
end;

function TProxyDesigner.GetAncestorDesigner: IFormDesigner;
begin
end;

function TProxyDesigner.IsSourceReadOnly: Boolean;
begin
   Result:= False;
end;
{$ENDIF}


function TProxyDesigner.GetRoot: TComponent;
begin
   Result:= nil;
end;

procedure TProxyDesigner.Revert(Instance: TPersistent; PropInfo: PPropInfo);
begin
end;

function TProxyDesigner.GetIsDormant: Boolean;
begin
   Result:= False;
end;

function TProxyDesigner.HasInterface: Boolean;
begin
   Result:= False;
end;

function TProxyDesigner.HasInterfaceMember(const Name: string): Boolean;
begin
   Result:= False;
end;

procedure TProxyDesigner.PaintGrid;
var
 i, j, HStart, HEnd, VStart, VEnd, HCount, VCount, X, Y, SizeX,SizeY: integer;
begin
  if not IniFile.ReadBool('SYSTEM','DisplayGrid',True) then Exit;
  SizeX:= IniFile.ReadInteger('SYSTEM','GridSizeX',8);
  SizeY:= IniFile.ReadInteger('SYSTEM','GridSizeY',8);
  with Form do
  begin
      Canvas.Pen.color := clBlack;
      Canvas.Pen.width := 1;
      VStart := (Canvas.ClipRect.Top div SizeY)    * SizeY;
      VEnd   := (Canvas.ClipRect.Bottom div SizeY) * SizeY;
      HStart := (Canvas.ClipRect.Left div SizeX)   * SizeX;
      HEnd   := (Canvas.ClipRect.Right div SizeX)  * SizeX;
      HCount := (HEnd - HStart) div SizeX + 1;
      VCount := (VEnd - VStart) div SizeY + 1;
      Y := VStart;
      for i := 1 to VCount do
      begin
         X := HStart;
         for j := 1 to HCount do
         begin
             Canvas.moveto(X, Y);
             Canvas.LineTo(X+1, Y+1);
             X := X + SizeX;
         end;
         Y := Y + SizeY;
      end;
    end;
end;

procedure TProxyDesigner.ValidateRename(AComponent: TComponent;
                               const CurName, NewName: string);
begin
end;

{ Create a new method called Name, whose type is TypeData. Assign a unique
  identifier for the method by using its index in the string list. Offset the
  index by 1, so that index 0 can be interpreted as a nil pointer. Thus, the
  first method in the list has index 1. After creating the method, show it
  to the user. }
function TProxyDesigner.CreateMethod(const Name: string; TypeData: PTypeData): TMethod;
begin
  if not MethodExists(Name) then
    Methods.AddObject(Name, TObject(TypeData));
  Result.Data := Form;
  Result.Code := Pointer(Methods.IndexOf(Name) + 1);
  ShowMethod(Name);
end;

{ Call Proc for each method whose type matches TypeData. }
procedure TProxyDesigner.GetMethods(TypeData: PTypeData; Proc: TGetStrProc);
var
  I: Integer;
begin
  with Methods do
    for I := 0 to Count-1 do
      if Objects[I] = TObject(TypeData) then
        Proc(Strings[I]);
end;

{ Get the name of a method whose pointer is TMethod. Look up the
  method name by its index in the method's Code field. Remember that
  indexes are offset by one. }
function TProxyDesigner.GetMethodName(const Method: TMethod): string;
var
   I:integer;
begin
  I:= Methods.IndexOfObject(Method.code);
  if Method.Code = nil then Result := ''
  else if I <> -1 then Result := Methods.Strings[I]
  else  Result:= Form.MethodName(Method.Code)
 // else  Result := Methods.Strings[Integer(Method.Code) - 1];
end;

{ Return whether a method exists with the given Name. }
function TProxyDesigner.MethodExists(const Name: string): Boolean;
begin
  Result := Methods.IndexOf(Name) >= 0;
end;

{ Rename a method from CurName to NewName. }
procedure TProxyDesigner.RenameMethod(const CurName, NewName: string);
var
  Index: Integer;
begin
  Index := Methods.IndexOf(CurName);
  if Index = -1 then Exit;
  Methods.Strings[Index] := NewName;
end;

{ Show a method to the user by highlighting it in the list box. }
procedure TProxyDesigner.ShowMethod(const Name: string);
begin
  //ComponentForm.MethodList.ItemIndex := Methods.IndexOf(Name);
end;

function TProxyDesigner.GetPrivateDirectory: string;
begin
end;

{$ifndef VER80}
{ No form inheritance in the debugging designer. }
function TProxyDesigner.MethodFromAncestor(const Method: TMethod): Boolean;
begin
  Result := False;
end;
{$endif}

// Set focus to next control when deleted selected components
procedure TProxyDesigner.FindNextControl;
var
  Name:string;
  Index:Integer;
begin
   if TProxyForm(Form).ComponentList.Count <= 0 then
   begin
      ObjectInspector.ComponentList.ItemIndex:=0;
      ObjectInspector.ComponentListClick(self);
      Exit;
   end;
   Name:= TProxyForm(Form).ComponentList[TProxyForm(Form).ComponentList.Count - 1];
   Index:= ObjectInspector.ComponentList.Items.IndexOf(Name);
   if Index <> -1 then
      ObjectInspector.ComponentList.ItemIndex:= Index
   else ObjectInspector.ComponentList.ItemIndex:=0;
   ObjectInspector.ComponentListClick(self);
end;

// Delete Control
procedure TProxyDesigner.DeleteControl(Control: TControl;Next:Boolean);
var
   Name:string;
   Index:Integer;
begin
   if (Control = nil) or (Control = Form) then Exit;
   Name:= Control.Name + ':' + Control.ClassName;
   Index:= TProxyForm(Form).ComponentList.IndexOf(Name);
   if Index <> -1 then  TProxyForm(Form).ComponentList.Delete(Index);
   ObjectInspector.ComponentList.Items.Delete(ObjectInspector.ComponentList.Items.IndexOf(Name));
   EditorForm.WriteComponentCode(Control.Name,
       TComponentClass(Control.ClassType),wrDelete);
   Control.Free;
   if Next then FindNextControl;  //  ۳Ʈ ã Ѵ.
end;

// Delete selected component list
procedure TProxyDesigner.DeleteSelectList;
var
  I:Integer;
begin
   TProxyForm(Form).SelectControl:= nil;
   for I:= 0 to fSelectList.Count - 1 do
      DeleteControl(fSelectList[I], False);
   fSelectList.Clear;
   ClearSelectList;
   FindNextControl;
   FMainForm.UpdateControl(psChange);
end;

procedure TProxyDesigner.ClearSelectList;
var
  I:Integer;
begin
   for I:=fGrabList.Count-1 downto 0 do
      TGrabHandles(fGrabList[I]).Free;
   fGrabList.Clear;
   fSelectList.Clear;
   if TProxyForm(Form).DragRectList <> nil then
      TProxyForm(Form).DragRectList.Clear;
end;

procedure TProxyDesigner.SelectComponent(Instance: TPersistent);
// Select component
var
  I,Index:Integer;
begin
  if Instance = nil then Exit;
  if IsSelected(TControl(Instance)) then Exit;
  if not fMultiSelected then ClearSelectList;
  fGrabHandles:= TGrabHandles.Create(TControl(Instance));
  if fMultiSelected then
  begin
  //  ۳Ʈ ý õ ۳Ʈ ,ġ  Ѵ.
     if fGrabList.Count >= 1 then
        TGrabHandles(fGrabList[0]).MultiSelected:= True;
     fGrabHandles.MultiSelected:= True;
  end;
  if TProxyForm(Form).DragRectList <> nil then
     TProxyForm(Form).DragRectList.Add(TControl(Instance));
  Index:= fSelectList.IndexOf(Instance);
  fGrabList.Add(TPersistent(fGrabHandles));
  //  ۳Ʈ Ͽ   , Ͽ ۳Ʈ ߰Ѵ.
  if Index = -1 then fSelectList.Add(Instance);
  TProxyForm(Form).SelectControl:= TControl(Instance);
end;

// Create new component
// ComponentClass: component's class
// Parent: component's parent
// Left,Top,Width,Height: component's position
function TProxyDesigner.CreateComponent(ComponentClass: TComponentClass;Parent:TComponent;
             Left,Top,Width,Height:Integer):TComponent;
var
  Component: TComponent;
  Control :TControl;
  Po: TPoint;
  LeftTop: LongInt;

  procedure SetControlPosition;
  begin
      if IniFile.ReadBool('SYSTEM','SnapGrid',True) then
      begin
         GetNearestGridPoint(Point(Left, Top), Po);
         if Left   > 0 then Control.Left  := Po.X;
         if Top    > 0 then Control.Top   := Po.Y;
         if Width  > 0 then Control.Width := Width;
         if Height > 0 then Control.Height:= Height;
      end
      else
      begin
         if Left   > 0 then Control.Left  := Left;
         if Top    > 0 then Control.Top   := Top;
         if Width  > 0 then Control.Width := Width;
         if Height > 0 then Control.Height:= Height;
      end;
  end;

begin
   Result:= nil;
   if ComponentClass = nil then Exit;
   Component:= ComponentClass.Create(Form);
   if Component is TControl then  // Create a control for visual component
   begin
      Control:= TControl(Component);
      Control.Name:= UniqueName(ComponentClass.ClassName);
      SetControlPosition;
      Control.Parent:= TWinControl(Parent);
   end
   else
   begin // Create a wrapper control for nonvisual components.
      Control:= TWrapperControl.Create(Form, Component);
      // Wrapper's name = 'wrapper' + component name
      Component.Name:= UniqueName(ComponentClass.ClassName);
      Control.Name:= 'Wrapper' + Component.Name;
      SetControlPosition;
      LongRec(LeftTop).Lo := Control.Left;
      LongRec(LeftTop).Hi := Control.Top;
      Component.DesignInfo:= LeftTop;
      Control.Parent      := TWinControl(Parent);
   end;
   EditorForm.CheckUseUnit(Control);
   //  ۳Ʈ ޼  ʵ csDesigning flag True Ѵ.
   TExposeComponent(Control).SetDesigning(True);
   // Create component's code at editor
   EditorForm.WriteComponentCode(Component.Name,ComponentClass,wrInsert);
   TProxyForm(Form).SelectControl:= Control;
   TProxyForm(Form).GrabHandles := fGrabHandles;
   FMainForm.UpdateControl(psChange);
   AddComponentList(Component);
   // Display component's property and value at object inspector
   if Control.ClassType = TWrapperControl then
      ObjectInspector.DisplayProperty(Control,(Control as TWrapperControl).Component)
   else ObjectInspector.DisplayProperty(nil,Control);
   // ۳Ʈ ȷƮ  ȭǥ ư Ѵ.
   if not FMainForm.ShiftKeyed then
      TSpeedButton(FMainForm.PageControl1.ActivePage.Controls[0]).Down:= True;
   Result:= Component;
end;

function TProxyDesigner.CreateWrapperComponent(Component: TComponent;
             Left,Top:Integer):TComponent;
var
  Control :TControl;
  Po: TPoint;
begin
   Result:= nil;
   if Component = nil then Exit;
   Control := TWrapperControl.Create(Form, Component);
   // Wrapper ̸ Wrapper+۳Ʈ ̸ Ѵ.
   Control.Name   := 'Wrapper'+Component.Name;
   Control.Left   := Left;
   Control.Top    := Top;
   Control.Parent := TWinControl(Form);
   EditorForm.CheckUseUnit(Control);
   //  ۳Ʈ ޼  ʵ csDesigning flag True Ѵ.
   TExposeComponent(Control).SetDesigning(True);
   TProxyForm(Form).GrabHandles := fGrabHandles;
   AddComponentList(Component);
   Result:= Component;
end;

{ǥ  Ģ Ͽ ۳Ʈ   ̸ Ѵ.  <Ÿ><>
  ϴµ, <Ÿ> ۳Ʈ Ŭ ̸ 'T'  ̰, <>
 ̸ ϰ   ̴.}
function TProxyDesigner.UniqueName(const BaseName:string):string;
var
  I:Integer;
  Fmt:string;
begin
   if BaseName[1] in ['t','T'] then  Fmt:= Copy(BaseName,2,255)+'%d'
   else Fmt:= BaseName + '%d';
   { ̸   ,  ڸ  Ѵ.}
   for I:=1 to High(Integer) do
   begin
      Result:= Format(Fmt,[I]);
      if Form.FindComponent(Result)= nil then Exit;
   end;
end;

//  ִ ۳Ʈ  Ѵ.
procedure TProxyDesigner.GetComponentList;
var
   I:integer;
begin
    ObjectInspector.ComponentList.Clear;
    ObjectInspector.ComponentList.Items.Add(Form.Name+':TForm');
    with Form do  begin
    for I:=0 to  ComponentCount-1 do
        if (Components[I].ClassType<>TGrabHandle) and (Components[I].ClassType<>TWrapperControl) then
           ObjectInspector.ComponentList.Items.Add(Components[I].Name+':'+Components[I].ClassName)
    end;
end;

// Ͻ   Ʈ  Ѵ.
function TProxyDesigner.GetFocusedControl(Msg: TMsg): TControl;
var
   FocusControl: TControl;
   I:Integer;
   P:TPoint;
begin
   FocusControl:=nil;
   if Msg.HWnd=Form.Handle then
   begin
      //  Ǵ WinControl ƴ ٸ ۳Ʈ  
      FocusControl:=Form.ControlAtPos(Form.ScreenToClient(Msg.Pt),True);
      if FocusControl = nil then  FocusControl:=Form;
   end
   else
   begin
       for I:=0 to Form.ComponentCount-1 do
          if (Form.Components[I] is TWinControl) and
             (Msg.HWnd=TWinControl(Form.Components[I]).Handle) then
             FocusControl:=TControl(Form.Components[I]);
   end;
   Result:=FocusControl;
end;

// ο ۳Ʈ Object Inspector ۳Ʈ Ͽ ߰Ѵ.
procedure TProxyDesigner.AddComponentList(Component:TComponent);
begin
   if Component = nil then Exit;
   ObjectInspector.ComponentList.Items.Add(Component.Name+':'+Component.ClassName);
   TProxyForm(Form).ComponentList.Add(Component.Name+':'+Component.ClassName);
   ComponentList.Add(Component);
end;

// Ͻ  ߻ϴ  ޼ óѴ.
function TProxyDesigner.IsDesignMsg(Sender: TControl;var Message: TMessage): Boolean;
begin
  Result := True;
  case Message.Msg of
     WM_KEYDOWN      : ProcessKeyDown   (Message);
     WM_KEYUP        : ProcessKeyUp     (Message);
     WM_LBUTTONDOWN  : ProcessMouseDown (Sender, Message);
     WM_RBUTTONDOWN  : ProcessRMouseDown(Sender, Message);
     WM_MOUSEMOVE    : ProcessMouseMove (Sender, Message);
     WM_LBUTTONDBLCLK: ProcessDblClick  (Sender, Message);
     WM_LBUTTONUP    : ProcessMouseUp   (Sender, Message);
     else Result:= False;
  end;
end;

function TProxyDesigner.CreatePopupMenu : TPopupMenu;
var
  Menu:TPopupMenu;
  Po:TPoint;
  Component:TComponent;
// ˾ ޴ ޴ ׸ ߰Ѵ.
procedure AddMenuItem(Menu:TPopupMenu;ItemName:string;Name:string;Enable:Boolean; ImgIndex: Integer);
var
   NewMenuItem:TMenuItem;
begin
   NewMenuItem        := TMenuItem.Create(Application);
   NewMenuItem.Name   := Name;
   NewMenuItem.Caption:= ItemName;
   NewMenuItem.Enabled:= Enable;
   NewMenuItem.OnClick:= TProxyForm(Form).OnMenuClick;
   if ImgIndex <> -1 then NewMenuItem.ImageIndex:= ImgIndex;
   Menu.Items.Add(NewMenuItem);
end;
begin
   Component:= Form.FindComponent('ProxyPopupMenu1');
   if Component <> nil then Component.Free;
   Menu       := TPopupMenu.Create(Form);
   Menu.Name  := 'ProxyPopupMenu1';
   Menu.Images:= FMainForm.ImageList;
   AddMenuItem(Menu, 'Cu&t'           ,'pmCut'       , True , 0);
   AddMenuItem(Menu, '&Copy'          ,'pmCopy'      , True , 1);
   if ClipBoard.HasFormat(CF_COMPONENT) then
      AddMenuItem(Menu, '&Paste'      ,'pmPaste'     , True , 2)
   else AddMenuItem(Menu, '&Paste'    ,'pmPaste'     , False, 2);
   AddMenuItem(Menu, '&Delete'        ,'pmDelete'    , True , 5);
   AddMenuItem(Menu, '-'              ,'pmSepa1'     , True , -1);
   AddMenuItem(Menu, 'Bring to &Front','pmFront'     , True , 58);
   AddMenuItem(Menu, 'Send to &Back'  ,'pmBack'      , True , 57);
   AddMenuItem(Menu, '-'              ,'pmSepa2'     , True , -1);
   AddMenuItem(Menu, '&Align...'      ,'pmAlign'     , True , 54);
   AddMenuItem(Menu, '&Size...'       ,'pmSize'      , True , 60);
   AddMenuItem(Menu, 'Scal&e...'      ,'pmScale'     , True , 56);
   AddMenuItem(Menu, '&View as Text'  ,'pmViewAsText', True , -1);
   GetCursorPos(Po);
   Menu.Popup(Po.X, Po.Y);
   Result:= Menu;
  // Form.Dispatch(Message);
end;

// Ͻ  ߻ϴ MouseDown ޼ óѴ.
procedure TProxyDesigner.ProcessRMouseDown(Sender:TControl;Message:TMessage);
begin
   CreatePopupMenu;
end;

// Ͻ  ߻ϴ MouseDown ޼ óѴ.
procedure TProxyDesigner.ProcessMouseDown(Sender:TControl;Message:TMessage);
var
  Control:TComponent;
begin
   // Ŀ ġ ִ ۳Ʈ ϰ,  Ӽ Inspector ش.
   Control:= Sender;
   if (Control <> nil) and (TProxyForm(Form).SelectControl <> Sender) then
   begin
      if Control.ClassType = TWrapperControl then
         ObjectInspector.DisplayProperty(Control,(Control as TWrapperControl).Component)
      else if Control.ClassType = TMenuItemButton then Exit
      else if  Control.ClassType<>TGrabHandle then
         if fMultiSelected then SelectComponent(Control)
         else ObjectInspector.DisplayProperty(nil,Control);
   end;
   TProxyForm(Form).SelectControl:= Sender;
   Form.Dispatch(Message);   //  ޼ Ѵ.
end;

// Ͻ  ߻ϴ MouseMove ޼ óѴ.
procedure TProxyDesigner.ProcessMouseMove(Sender:TControl;Message:TMessage);
begin
   if fMultiSelected then Exit;
   Form.Dispatch(Message);
end;

// Ͻ  ߻ϴ MouseUp ޼ óѴ.
procedure TProxyDesigner.ProcessMouseUp(Sender:TControl;Message:TMessage);
begin
   Form.Dispatch(Message);
end;

// Ͻ  ߻ϴ DblClick ޼ óѴ.
// DblClick  ⺻ ó ۳Ʈ ⸦ ȣϴ ̴.
procedure TProxyDesigner.ProcessDblClick(Sender:TControl;Message:TMessage);
var
  CompEditor: TDefaultEditor;
begin
  { with ObjectInspector do begin
      SetFocus;
      PageControl1.ActivePage:= ObjectInspector.TabEvent;
      EventBox.ItemIndex:=0;
      EventBoxClick(self);
      edEventDblClick(self);
   end;}
   CompEditor:= TDefaultEditor(GetComponentEditor(Sender, ProxyDesigner));
   if CompEditor <> nil then
     if CompEditor is TYB_DefaultEditor then
        TYB_DefaultEditor(CompEditor).Edit
     else CompEditor.Edit;
end;

// Ͻ  ߻ϴ KeyDown ޼ óѴ.
procedure TProxyDesigner.ProcessKeyDown(Message:TMessage);
var
  KeyWord:string;
begin
   case TWMKey(Message).CharCode of
       VK_DELETE:
          DeleteSelectList;
       VK_F1:
       begin
          KeyWord:= TProxyForm(Form).SelectControl.ClassName;
          Application.HelpCommand(HELP_KEY, longint(KeyWord));
       end;
       VK_LEFT,VK_UP,VK_RIGHT,VK_DOWN:
       begin
          if fControlPressed then MoveControl(TWMKey(Message).CharCode);
       end;
       VK_F11:
          ObjectInspector.SetFocus;
       VK_F12:
          FMainForm.ToggleFormAndUnit;
       VK_SHIFT :
          fMultiSelected:= True;
       VK_CONTROL :
          fControlPressed:= True;
   end;
  // Form.Dispatch(Message);
end;

// Ͻ  ߻ϴ KeyUp ޼ óѴ.
procedure TProxyDesigner.ProcessKeyUp(Message:TMessage);
begin
   case TWMKey(Message).CharCode of
       VK_SHIFT :
          fMultiSelected:= False;
       VK_CONTROL :
       begin
          fControlPressed:= False;
          UpdateGrabHandle;
       end;
   end;
  // Form.Dispatch(Message);
end;

procedure TProxyDesigner.UpdateGrabHandle;
// Update grabs position
var
  I:Integer;
begin
   for I:=0 to fGrabList.Count - 1 do
     if Assigned(fGrabList[I]) then TGrabHandles(fGrabList[I]).Update;
end;

// Copy selected components to clipboard
procedure TProxyDesigner.CopyComponent;
var
  S: TMemoryStream;
  W: TWriter;
  I: Integer;
begin
  S := TMemoryStream.Create;
  try
    W := TWriter.Create(S, 1024);
    try
      W.Root := Form;
      for I := 0 to fSelectList.Count - 1 do
      begin
        W.WriteSignature;
        W.WriteComponent(TComponent(fSelectList[I]));
      end;
      W.WriteListEnd;
    finally
      W.Free;
    end;
    SetBuffer(CF_COMPONENT, S.Memory^, S.Size);
  finally
    S.Free;
  end;
end;

procedure TProxyDesigner.UndoComponent;
begin
end;

// Cut selected compoenents
procedure TProxyDesigner.CutComponent;
begin
   CopyComponent;
   DeleteSelectList;
   FMainForm.UpdateControl(psChange);
   FUndoList.AddChange(utCut, '');
end;

// Paste components
procedure TProxyDesigner.PasteComponent;
var
  S: TMemoryStream;
  R: TReader;
  Data: THandle;
  DataPtr: Pointer;
begin
  ClipBoard.Open;
  Data := GetClipboardData(CF_COMPONENT);
  if Data = 0 then Exit;
  DataPtr := GlobalLock(Data);
  if DataPtr = nil then Exit;
  S:= TMemoryStream.Create;
  ClearGrabHandles;
  fMultiSelected:= True;
  try
    S.WriteBuffer(DataPtr^, GlobalSize(Data));
    S.Position := 0;
    R := TReader.Create(S, 1024);
    try
      FMainForm.ReadClass;
      R.OnSetName := ReaderSetName;
      R.ReadComponents(Form, Form, ComponentRead);
    finally
      R.Free;
    end;
  finally
    S.Free;
    GlobalUnlock(Data);
  end;
  FMainForm.UpdateControl(psChange);
  fMultiSelected:= False;
end;

procedure TProxyDesigner.ReaderSetName(Reader: TReader; Component: TComponent;
  var Name: string);
begin
   Name := UniqueName(Component.ClassName);
end;

// ٿֱ⸦   ۳Ʈ ġ ComponentState Ѵ.
procedure TProxyDesigner.ComponentRead(Component: TComponent);
begin
   TExposeComponent(Component).SetDesigning(True);
   TControl(Component).Left:= TControl(Component).Left + 10;
   TControl(Component).Top:= TControl(Component).Top + 10;
   TProxyForm(Form).SelectControl:= TControl(Component);
   AddComponentList(Component);
   SelectComponent(Component);
end;

procedure TProxyDesigner.ClearGrabHandles;
var
  I,Index:Integer;
begin
  if (fGrabHandles <> nil) then
  begin
     for I:=fGrabList.Count-1 downto 0 do
     begin
        TGrabHandles(fGrabList[I]).Free;
        fGrabList.Delete(I);
     end;
  end;
  fSelectList.Clear;
end;

procedure TProxyDesigner.SelectAll;
var
  I:Integer;
begin
   ClearGrabHandles;
   fMultiSelected:= True;
   with Form do
   begin
     for I:=0 to ComponentCount-1 do
        if (Components[I].ClassType<>TGrabHandle) and
        (Components[I].ClassType<>TWrapperControl) then
           SelectComponent(Components[I]);
   end;
   fMultiSelected:= False;
end;

function TProxyDesigner.IsSelected(Control:TControl): Boolean ;
var
  Index:Integer;
begin
   Index:= fSelectList.IndexOf(Control);
   Result:= (Index  <> -1);
end;

procedure TProxyDesigner.MoveControl(Key:Word);
var
  I:Integer;
begin
   case Key of
      VK_RIGHT:
      begin
         for I:= 0 to fSelectList.Count-1 do
            TControl(fSelectList[I]).Left:= TControl(fSelectList[I]).Left + 1;
         if fSelectList.Count < 5 then UpdateGrabHandle;
      end;
      VK_LEFT:
      begin
         for I:= 0 to fSelectList.Count-1 do
            TControl(fSelectList[I]).Left:= TControl(fSelectList[I]).Left - 1;
         if fSelectList.Count < 5 then UpdateGrabHandle;
      end;
      VK_UP:
      begin
         for I:= 0 to fSelectList.Count-1 do
            TControl(fSelectList[I]).Top:= TControl(fSelectList[I]).Top - 1;
         if fSelectList.Count < 5 then UpdateGrabHandle;
      end;
      VK_DOWN:
      begin
         for I:= 0 to fSelectList.Count-1 do
            TControl(fSelectList[I]).Top:= TControl(fSelectList[I]).Top + 1;
         if fSelectList.Count < 5 then UpdateGrabHandle;
      end;
   end;
end;

procedure TProxyDesigner.SetProxyForm(Value: TCustomForm);
begin
   if Form <> Value then
   begin
     Form:= Value;
     fGrabList.Clear;
     fSelectList.Clear;
     ObjectInspector.InitializeInspector;
     ObjectInspector.DisplayProperty(nil,Form);
   end;
end;

procedure TProxyDesigner.CreateMenuItemComponent(Component: TComponent);
// Menu MenuItem ׸ ش.
var
   I, Len, Position: Integer;
   MenuItemLabel: TMenuItemButton;
begin
   if Component = nil then Exit;
   Position:= 0;
   for I:= 0 to TMenu(Component).Items.Count - 1 do
   begin
      MenuItemLabel := TMenuItemButton.Create(Form);
      MenuItemLabel.Caption:= (TMainMenu(Component).Items[I] as TMenuItem).Caption;
      MenuItemLabel.Name:= 'MenuItem'+(TMainMenu(Component).Items[I] as TMenuItem).Name;
      MenuItemLabel.Left:= Position;
      MenuItemLabel.Flat:= True;
      Len:= 8 * Length(MenuItemLabel.Caption) + 1;
      Position:= Position + Len;
      MenuItemLabel.Top:= 0;
      MenuItemLabel.Parent := TWinControl(Form);
   end;
end;

function TProxyDesigner.IsDesignedComponent(Component: TComponent): Boolean;
begin
   Result:= False;
   if (Component is TWrapperControl) or (Component is TMenuItemButton)
      or (Component is TGrabHandle) then
      Result:= True;
end;

procedure TProxyDesigner.SetSelectionList(List: TComponentList);
// Replace SetSelections procedure with SetSelectionList at Delphi 4 or up
var
  I: Integer;
begin
  ClearSelectList;
  if List.Count > 1 then FMultiSelected:= True;
  for I:= 0 to List.Count - 1 do
     SelectComponent(List[I]);
  FMultiSelected:= False;
end;

{ TUndoList }

procedure TUndoList.AddChange(ChangeReason: TUndoType; ChangeList: string);
begin

end;

procedure TUndoList.ClearList;
begin

end;

constructor TUndoList.Create;
begin

end;

destructor TUndoList.Destroy;
begin

end;

function TUndoList.GetCanUndo: Integer;
begin
   Result:= -1;
end;

procedure TUndoList.LockUndo;
begin

end;

procedure TUndoList.RemoveChange(index: Integer);
begin

end;

procedure TUndoList.UnLockUndo;
begin

end;

end.
